require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__i386_UACCESS_H)) {
    eval 'sub __i386_UACCESS_H () {1;}' unless defined(&__i386_UACCESS_H);
    require 'linux/errno.ph';
    require 'linux/thread_info.ph';
    require 'linux/prefetch.ph';
    require 'linux/string.ph';
    require 'asm/page.ph';
    eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
    eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
    eval 'sub MAKE_MM_SEG {
        my($s) = @_;
	    eval q((( &mm_segment_t) { ($s) }));
    }' unless defined(&MAKE_MM_SEG);
    eval 'sub KERNEL_DS () { &MAKE_MM_SEG(0xffffffff);}' unless defined(&KERNEL_DS);
    eval 'sub USER_DS () { &MAKE_MM_SEG( &TASK_SIZE);}' unless defined(&USER_DS);
    eval 'sub get_ds () {
        eval q(( &KERNEL_DS));
    }' unless defined(&get_ds);
    eval 'sub get_fs () {
        eval q(( &current_thread_info()-> &addr_limit));
    }' unless defined(&get_fs);
    eval 'sub set_fs {
        my($x) = @_;
	    eval q(( &current_thread_info()-> &addr_limit = ($x)));
    }' unless defined(&set_fs);
    eval 'sub segment_eq {
        my($a,$b) = @_;
	    eval q((($a). &seg == ($b). &seg));
    }' unless defined(&segment_eq);
    if(defined(&CONFIG_X86_INTEL_USERCOPY)) {
    }
    eval 'sub __addr_ok {
        my($addr) = @_;
	    eval q((($addr) < ( &current_thread_info()-> ($addr_limit->{seg}))));
    }' unless defined(&__addr_ok);
    eval 'sub __range_ok {
        my($addr,$size) = @_;
	    eval q(({ \'unsigned long flag\', &sum;  &__chk_user_ptr;  &asm(\\"addl %3,%1 ; sbbl %0,%0; cmpl %1,%4; sbbl $0,%0\\" :\\"=&r\\" , \\"=r\\" :\\"1\\" ,\\"g\\" (($size)),\\"rm\\" ( &current_thread_info()-> ($addr_limit->{seg})));  &flag; }));
    }' unless defined(&__range_ok);
    eval 'sub access_ok {
        my($type,$addr,$size) = @_;
	    eval q(( &likely( &__range_ok($addr,$size) == 0)));
    }' unless defined(&access_ok);
    eval 'sub __get_user_x {
        my($size,$ret,$x,$ptr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__get_user_x);
    eval 'sub indirect_get_user {
        my($x,$ptr) = @_;
	    eval q(({ \'int\'  &__ret_gu, &__val_gu;  &__typeof__($ptr)  &__ptr_gu = ($ptr);  &__ret_gu =  &get_user_size($sizeof{ &__ptr_gu}, & &__val_gu, &__ptr_gu) ? - &EFAULT : 0;  &barrier(); ($x) = ( &__typeof__(* &__ptr_gu)) &__val_gu;  &__ret_gu; }));
    }' unless defined(&indirect_get_user);
    eval 'sub indirect_put_user {
        my($x,$ptr) = @_;
	    eval q(({ \'int\'  &__ret_pu;  &__typeof__(*($ptr)) * &__ptr_pu = ($ptr),  &__x_pu = ($x);  &__ret_pu =  &put_user_size($sizeof{ &__ptr_pu}, & &__x_pu,  &__ptr_pu) ? - &EFAULT : 0;  &barrier();  &__ret_pu; }));
    }' unless defined(&indirect_put_user);
    eval 'sub __indirect_put_user () { &indirect_put_user;}' unless defined(&__indirect_put_user);
    eval 'sub __indirect_get_user () { &indirect_get_user;}' unless defined(&__indirect_get_user);
    eval 'sub indirect_copy_from_user {
        my($to,$from,$n) = @_;
	    eval q( &get_user_size($n,$to,$from));
    }' unless defined(&indirect_copy_from_user);
    eval 'sub indirect_copy_to_user {
        my($to,$from,$n) = @_;
	    eval q( &put_user_size($n,$from,$to));
    }' unless defined(&indirect_copy_to_user);
    eval 'sub __indirect_copy_from_user () { &indirect_copy_from_user;}' unless defined(&__indirect_copy_from_user);
    eval 'sub __indirect_copy_to_user () { &indirect_copy_to_user;}' unless defined(&__indirect_copy_to_user);
    eval 'sub indirect_strncpy_from_user {
        my($dst, $src, $count) = @_;
	    eval q( &copy_str_fromuser_size($count, $dst, $src));
    }' unless defined(&indirect_strncpy_from_user);
    eval 'sub indirect_strnlen_user {
        my($str, $n) = @_;
	    eval q( &strlen_fromuser_size($n, $str));
    }' unless defined(&indirect_strnlen_user);
    eval 'sub indirect_strlen_user {
        my($str) = @_;
	    eval q( &indirect_strnlen_user($str, ~0 >> 1));
    }' unless defined(&indirect_strlen_user);
    eval 'sub indirect_clear_user {
        my($mem, $len) = @_;
	    eval q( &zero_user_size($len, $mem));
    }' unless defined(&indirect_clear_user);
    eval 'sub __indirect_clear_user () { &clear_user;}' unless defined(&__indirect_clear_user);
    eval 'sub direct_get_user {
        my($x,$ptr) = @_;
	    eval q(({ \'int\'  &__ret_gu; \'unsigned long __val_gu\';  &__chk_user_ptr($ptr);  &switch($sizeof{($ptr)}) {  &case 1:  &__get_user_x(1, &__ret_gu, &__val_gu,$ptr);  &break;  &case 2:  &__get_user_x(2, &__ret_gu, &__val_gu,$ptr);  &break;  &case 4:  &__get_user_x(4, &__ret_gu, &__val_gu,$ptr);  &break;  &default:  &__get_user_x( &X, &__ret_gu, &__val_gu,$ptr);  &break; } ($x) = ( &__typeof__(*($ptr))) &__val_gu;  &__ret_gu; }));
    }' unless defined(&direct_get_user);
    eval 'sub __put_user_1 {
        my($x, $ptr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__put_user_1);
    eval 'sub __put_user_2 {
        my($x, $ptr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__put_user_2);
    eval 'sub __put_user_4 {
        my($x, $ptr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__put_user_4);
    eval 'sub __put_user_8 {
        my($x, $ptr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__put_user_8);
    eval 'sub __put_user_X {
        my($x, $ptr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__put_user_X);
    if(defined(&CONFIG_X86_WP_WORKS_OK)) {
	eval 'sub direct_put_user {
	    my($x,$ptr) = @_;
    	    eval q(({ \'int\'  &__ret_pu;  &__typeof__(*($ptr))  &__pu_val;  &__chk_user_ptr($ptr);  &__pu_val = $x;  &switch($sizeof{($ptr)}) {  &case 1:  &__put_user_1( &__pu_val, $ptr);  &break;  &case 2:  &__put_user_2( &__pu_val, $ptr);  &break;  &case 4:  &__put_user_4( &__pu_val, $ptr);  &break;  &case 8:  &__put_user_8( &__pu_val, $ptr);  &break;  &default: &__put_user_X( &__pu_val, $ptr);  &break; }  &__ret_pu; }));
	}' unless defined(&direct_put_user);
    } else {
	eval 'sub direct_put_user {
	    my($x,$ptr) = @_;
    	    eval q(({ \'int\'  &__ret_pu;  &__typeof__(*($ptr))  &__pus_tmp = $x;  &__ret_pu=0;  &if( &unlikely( &__copy_to_user_ll($ptr, & &__pus_tmp, $sizeof{($ptr)}) != 0))  &__ret_pu=- &EFAULT;  &__ret_pu; }));
	}' unless defined(&direct_put_user);
    }
    eval 'sub __direct_get_user {
        my($x,$ptr) = @_;
	    eval q( &__get_user_nocheck(($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&__direct_get_user);
    eval 'sub __direct_put_user {
        my($x,$ptr) = @_;
	    eval q( &__put_user_nocheck(( &__typeof__(*($ptr)))($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&__direct_put_user);
    eval 'sub __put_user_nocheck {
        my($x,$ptr,$size) = @_;
	    eval q(({ \'long __pu_err\';  &__put_user_size(($x),($ptr),($size), &__pu_err,- &EFAULT);  &__pu_err; }));
    }' unless defined(&__put_user_nocheck);
    eval 'sub __put_user_u64 {
        my($x, $addr, $err) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__put_user_u64);
    if(defined(&CONFIG_X86_WP_WORKS_OK)) {
	eval 'sub __put_user_size {
	    my($x,$ptr,$size,$retval,$errret) = @_;
    	    eval q( &do { $retval = 0;  &__chk_user_ptr($ptr);  &switch ($size) {  &case 1:  &__put_user_asm($x,$ptr,$retval,\\"b\\",\\"b\\",\\"iq\\",$errret); &break;  &case 2:  &__put_user_asm($x,$ptr,$retval,\\"w\\",\\"w\\",\\"ir\\",$errret); &break;  &case 4:  &__put_user_asm($x,$ptr,$retval,\\"l\\",\\"\\",\\"ir\\",$errret);  &break;  &case 8:  &__put_user_u64(( &__typeof__(*$ptr))($x),$ptr,$retval);  &break;  &default:  &__put_user_bad(); } }  &while (0));
	}' unless defined(&__put_user_size);
    } else {
	eval 'sub __put_user_size {
	    my($x,$ptr,$size,$retval,$errret) = @_;
    	    eval q( &do {  &__typeof__(*($ptr))  &__pus_tmp = $x; $retval = 0;  &if( &unlikely( &__copy_to_user_ll($ptr, & &__pus_tmp, $size) != 0)) $retval = $errret; }  &while (0));
	}' unless defined(&__put_user_size);
    }
    eval 'sub __m {
        my($x) = @_;
	    eval q((*(\'struct __large_struct\'  &__user *)($x)));
    }' unless defined(&__m);
    eval 'sub __put_user_asm {
        my($x, $addr, $err, $itype, $rtype, $ltype, $errret) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__put_user_asm);
    eval 'sub __get_user_nocheck {
        my($x,$ptr,$size) = @_;
	    eval q(({ \'long __gu_err\'; \'unsigned long __gu_val\';  &__get_user_size( &__gu_val,($ptr),($size), &__gu_err,- &EFAULT); ($x) = ( &__typeof__(*($ptr))) &__gu_val;  &__gu_err; }));
    }' unless defined(&__get_user_nocheck);
    eval 'sub __get_user_size {
        my($x,$ptr,$size,$retval,$errret) = @_;
	    eval q( &do { $retval = 0;  &__chk_user_ptr($ptr);  &switch ($size) {  &case 1:  &__get_user_asm($x,$ptr,$retval,\\"b\\",\\"b\\",\\"=q\\",$errret); &break;  &case 2:  &__get_user_asm($x,$ptr,$retval,\\"w\\",\\"w\\",\\"=r\\",$errret); &break;  &case 4:  &__get_user_asm($x,$ptr,$retval,\\"l\\",\\"\\",\\"=r\\",$errret); &break;  &default: ($x) =  &__get_user_bad(); } }  &while (0));
    }' unless defined(&__get_user_size);
    eval 'sub __get_user_asm {
        my($x, $addr, $err, $itype, $rtype, $ltype, $errret) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__get_user_asm);
    unless(defined(&CONFIG_X86_UACCESS_INDIRECT)) {
	eval 'sub ARCH_HAS_NOCACHE_UACCESS () {1;}' unless defined(&ARCH_HAS_NOCACHE_UACCESS);
    }
    eval 'sub direct_strlen_user {
        my($str) = @_;
	    eval q( &direct_strnlen_user($str, ~0 >> 1));
    }' unless defined(&direct_strlen_user);
    if(defined(&CONFIG_X86_UACCESS_INDIRECT)) {
	eval 'sub __clear_user {
	    my($mem,$len) = @_;
    	    eval q( &__indirect_clear_user($mem,$len));
	}' unless defined(&__clear_user);
	eval 'sub clear_user {
	    my($mem,$len) = @_;
    	    eval q( &indirect_clear_user($mem,$len));
	}' unless defined(&clear_user);
	eval 'sub __copy_to_user {
	    my($to,$from,$n) = @_;
    	    eval q( &__indirect_copy_to_user($to,$from,$n));
	}' unless defined(&__copy_to_user);
	eval 'sub __copy_to_user_inatomic {
	    my($to,$from,$n) = @_;
    	    eval q( &__indirect_copy_to_user($to,$from,$n));
	}' unless defined(&__copy_to_user_inatomic);
	eval 'sub copy_to_user {
	    my($to,$from,$n) = @_;
    	    eval q( &indirect_copy_to_user($to,$from,$n));
	}' unless defined(&copy_to_user);
	eval 'sub __copy_from_user {
	    my($to,$from,$n) = @_;
    	    eval q( &__indirect_copy_from_user($to,$from,$n));
	}' unless defined(&__copy_from_user);
	eval 'sub __copy_from_user_inatomic {
	    my($to,$from,$n) = @_;
    	    eval q( &__indirect_copy_from_user($to,$from,$n));
	}' unless defined(&__copy_from_user_inatomic);
	eval 'sub copy_from_user {
	    my($to,$from,$n) = @_;
    	    eval q( &indirect_copy_from_user($to,$from,$n));
	}' unless defined(&copy_from_user);
	eval 'sub __get_user {
	    my($val,$ptr) = @_;
    	    eval q( &__indirect_get_user($val,$ptr));
	}' unless defined(&__get_user);
	eval 'sub get_user {
	    my($val,$ptr) = @_;
    	    eval q( &indirect_get_user($val,$ptr));
	}' unless defined(&get_user);
	eval 'sub __put_user {
	    my($val,$ptr) = @_;
    	    eval q( &__indirect_put_user($val,$ptr));
	}' unless defined(&__put_user);
	eval 'sub put_user {
	    my($val,$ptr) = @_;
    	    eval q( &indirect_put_user($val,$ptr));
	}' unless defined(&put_user);
	eval 'sub strlen_user {
	    my($str) = @_;
    	    eval q( &indirect_strlen_user($str));
	}' unless defined(&strlen_user);
	eval 'sub strnlen_user {
	    my($src,$count) = @_;
    	    eval q( &indirect_strnlen_user($src,$count));
	}' unless defined(&strnlen_user);
	eval 'sub strncpy_from_user {
	    my($dst,$src,$count) = @_;
    	    eval q( &indirect_strncpy_from_user($dst,$src,$count));
	}' unless defined(&strncpy_from_user);
    } else {
	eval 'sub __clear_user () { &__direct_clear_user;}' unless defined(&__clear_user);
	eval 'sub clear_user () { &direct_clear_user;}' unless defined(&clear_user);
	eval 'sub __copy_to_user () { &__direct_copy_to_user_inatomic;}' unless defined(&__copy_to_user);
	eval 'sub __copy_to_user_inatomic () { &__direct_copy_to_user_inatomic;}' unless defined(&__copy_to_user_inatomic);
	eval 'sub __direct_copy_to_user () { &__direct_copy_to_user_inatomic;}' unless defined(&__direct_copy_to_user);
	eval 'sub copy_to_user () { &direct_copy_to_user;}' unless defined(&copy_to_user);
	eval 'sub __copy_from_user () { &__direct_copy_from_user_inatomic;}' unless defined(&__copy_from_user);
	eval 'sub __copy_from_user_inatomic () { &__direct_copy_from_user_inatomic;}' unless defined(&__copy_from_user_inatomic);
	eval 'sub __direct_copy_from_user () { &__direct_copy_from_user_inatomic;}' unless defined(&__direct_copy_from_user);
	eval 'sub copy_from_user () { &direct_copy_from_user;}' unless defined(&copy_from_user);
	eval 'sub __get_user () { &__direct_get_user;}' unless defined(&__get_user);
	eval 'sub get_user () { &direct_get_user;}' unless defined(&get_user);
	eval 'sub __put_user () { &__direct_put_user;}' unless defined(&__put_user);
	eval 'sub put_user () { &direct_put_user;}' unless defined(&put_user);
	eval 'sub strlen_user () { &direct_strlen_user;}' unless defined(&strlen_user);
	eval 'sub strnlen_user () { &direct_strnlen_user;}' unless defined(&strnlen_user);
	eval 'sub strncpy_from_user () { &direct_strncpy_from_user;}' unless defined(&strncpy_from_user);
    }
}
1;
