require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_INTEL_IOMMU_H_)) {
    eval 'sub _INTEL_IOMMU_H_ () {1;}' unless defined(&_INTEL_IOMMU_H_);
    require 'linux/types.ph';
    require 'linux/iova.ph';
    require 'linux/io.ph';
    require 'linux/dma_remapping.ph';
    require 'asm/cacheflush.ph';
    require 'asm/proto.ph';
    unless(defined(&for_each_sg)) {
	eval 'sub for_each_sg {
	    my($sglist, $sg, $nr, $__i) = @_;
    	    eval q( &for ($__i = 0, $sg = ($sglist); $__i < ($nr); $__i++, $sg++));
	}' unless defined(&for_each_sg);
    }
    eval 'sub DMAR_VER_REG () {0x;}' unless defined(&DMAR_VER_REG);
    eval 'sub DMAR_CAP_REG () {0x8;}' unless defined(&DMAR_CAP_REG);
    eval 'sub DMAR_ECAP_REG () {0x10;}' unless defined(&DMAR_ECAP_REG);
    eval 'sub DMAR_GCMD_REG () {0x18;}' unless defined(&DMAR_GCMD_REG);
    eval 'sub DMAR_GSTS_REG () {0x1c;}' unless defined(&DMAR_GSTS_REG);
    eval 'sub DMAR_RTADDR_REG () {0x20;}' unless defined(&DMAR_RTADDR_REG);
    eval 'sub DMAR_CCMD_REG () {0x28;}' unless defined(&DMAR_CCMD_REG);
    eval 'sub DMAR_FSTS_REG () {0x34;}' unless defined(&DMAR_FSTS_REG);
    eval 'sub DMAR_FECTL_REG () {0x38;}' unless defined(&DMAR_FECTL_REG);
    eval 'sub DMAR_FEDATA_REG () {0x3c;}' unless defined(&DMAR_FEDATA_REG);
    eval 'sub DMAR_FEADDR_REG () {0x40;}' unless defined(&DMAR_FEADDR_REG);
    eval 'sub DMAR_FEUADDR_REG () {0x44;}' unless defined(&DMAR_FEUADDR_REG);
    eval 'sub DMAR_AFLOG_REG () {0x58;}' unless defined(&DMAR_AFLOG_REG);
    eval 'sub DMAR_PMEN_REG () {0x64;}' unless defined(&DMAR_PMEN_REG);
    eval 'sub DMAR_PLMBASE_REG () {0x68;}' unless defined(&DMAR_PLMBASE_REG);
    eval 'sub DMAR_PLMLIMIT_REG () {0x6c;}' unless defined(&DMAR_PLMLIMIT_REG);
    eval 'sub DMAR_PHMBASE_REG () {0x70;}' unless defined(&DMAR_PHMBASE_REG);
    eval 'sub DMAR_PHMLIMIT_REG () {0x78;}' unless defined(&DMAR_PHMLIMIT_REG);
    eval 'sub DMAR_IQH_REG () {0x80;}' unless defined(&DMAR_IQH_REG);
    eval 'sub DMAR_IQT_REG () {0x88;}' unless defined(&DMAR_IQT_REG);
    eval 'sub DMAR_IQ_SHIFT () {4;}' unless defined(&DMAR_IQ_SHIFT);
    eval 'sub DMAR_IQA_REG () {0x90;}' unless defined(&DMAR_IQA_REG);
    eval 'sub DMAR_ICS_REG () {0x98;}' unless defined(&DMAR_ICS_REG);
    eval 'sub DMAR_IRTA_REG () {0xb8;}' unless defined(&DMAR_IRTA_REG);
    eval 'sub OFFSET_STRIDE () {(9);}' unless defined(&OFFSET_STRIDE);
    eval 'sub dmar_writeq {
        my($addr,$val) = @_;
	    eval q({  &writel(( &u32)$val, $addr);  &writel(( &u32)($val >> 32), $addr + 4); });
    }' unless defined(&dmar_writeq);
    eval 'sub DMAR_VER_MAJOR {
        my($v) = @_;
	    eval q(((($v) & 0xf0) >> 4));
    }' unless defined(&DMAR_VER_MAJOR);
    eval 'sub DMAR_VER_MINOR {
        my($v) = @_;
	    eval q((($v) & 0xf));
    }' unless defined(&DMAR_VER_MINOR);
    eval 'sub cap_read_drain {
        my($c) = @_;
	    eval q(((($c) >> 55) & 1));
    }' unless defined(&cap_read_drain);
    eval 'sub cap_write_drain {
        my($c) = @_;
	    eval q(((($c) >> 54) & 1));
    }' unless defined(&cap_write_drain);
    eval 'sub cap_max_amask_val {
        my($c) = @_;
	    eval q(((($c) >> 48) & 0x3f));
    }' unless defined(&cap_max_amask_val);
    eval 'sub cap_num_fault_regs {
        my($c) = @_;
	    eval q((((($c) >> 40) & 0xff) + 1));
    }' unless defined(&cap_num_fault_regs);
    eval 'sub cap_pgsel_inv {
        my($c) = @_;
	    eval q(((($c) >> 39) & 1));
    }' unless defined(&cap_pgsel_inv);
    eval 'sub cap_super_page_val {
        my($c) = @_;
	    eval q(((($c) >> 34) & 0xf));
    }' unless defined(&cap_super_page_val);
    eval 'sub cap_super_offset {
        my($c) = @_;
	    eval q(((( &find_first_bit( &cap_super_page_val($c), 4)) *  &OFFSET_STRIDE) + 21));
    }' unless defined(&cap_super_offset);
    eval 'sub cap_fault_reg_offset {
        my($c) = @_;
	    eval q((((($c) >> 24) & 0x3ff) * 16));
    }' unless defined(&cap_fault_reg_offset);
    eval 'sub cap_max_fault_reg_offset {
        my($c) = @_;
	    eval q(( &cap_fault_reg_offset($c) +  &cap_num_fault_regs($c) * 16));
    }' unless defined(&cap_max_fault_reg_offset);
    eval 'sub cap_zlr {
        my($c) = @_;
	    eval q(((($c) >> 22) & 1));
    }' unless defined(&cap_zlr);
    eval 'sub cap_isoch {
        my($c) = @_;
	    eval q(((($c) >> 23) & 1));
    }' unless defined(&cap_isoch);
    eval 'sub cap_mgaw {
        my($c) = @_;
	    eval q((((($c) >> 16) & 0x3f) + 1));
    }' unless defined(&cap_mgaw);
    eval 'sub cap_sagaw {
        my($c) = @_;
	    eval q(((($c) >> 8) & 0x1f));
    }' unless defined(&cap_sagaw);
    eval 'sub cap_caching_mode {
        my($c) = @_;
	    eval q(((($c) >> 7) & 1));
    }' unless defined(&cap_caching_mode);
    eval 'sub cap_phmr {
        my($c) = @_;
	    eval q(((($c) >> 6) & 1));
    }' unless defined(&cap_phmr);
    eval 'sub cap_plmr {
        my($c) = @_;
	    eval q(((($c) >> 5) & 1));
    }' unless defined(&cap_plmr);
    eval 'sub cap_rwbf {
        my($c) = @_;
	    eval q(((($c) >> 4) & 1));
    }' unless defined(&cap_rwbf);
    eval 'sub cap_afl {
        my($c) = @_;
	    eval q(((($c) >> 3) & 1));
    }' unless defined(&cap_afl);
    eval 'sub cap_ndoms {
        my($c) = @_;
	    eval q(((1) << (4+ 2* (($c) & 0x7))));
    }' unless defined(&cap_ndoms);
    eval 'sub ecap_niotlb_iunits {
        my($e) = @_;
	    eval q((((($e) >> 24) & 0xff) + 1));
    }' unless defined(&ecap_niotlb_iunits);
    eval 'sub ecap_iotlb_offset {
        my($e) = @_;
	    eval q((((($e) >> 8) & 0x3ff) * 16));
    }' unless defined(&ecap_iotlb_offset);
    eval 'sub ecap_max_iotlb_offset {
        my($e) = @_;
	    eval q(( &ecap_iotlb_offset($e) +  &ecap_niotlb_iunits($e) * 16));
    }' unless defined(&ecap_max_iotlb_offset);
    eval 'sub ecap_coherent {
        my($e) = @_;
	    eval q((($e) & 0x1));
    }' unless defined(&ecap_coherent);
    eval 'sub ecap_qis {
        my($e) = @_;
	    eval q((($e) & 0x2));
    }' unless defined(&ecap_qis);
    eval 'sub ecap_pass_through {
        my($e) = @_;
	    eval q((($e >> 6) & 0x1));
    }' unless defined(&ecap_pass_through);
    eval 'sub ecap_eim_support {
        my($e) = @_;
	    eval q((($e >> 4) & 0x1));
    }' unless defined(&ecap_eim_support);
    eval 'sub ecap_ir_support {
        my($e) = @_;
	    eval q((($e >> 3) & 0x1));
    }' unless defined(&ecap_ir_support);
    eval 'sub ecap_dev_iotlb_support {
        my($e) = @_;
	    eval q(((($e) >> 2) & 0x1));
    }' unless defined(&ecap_dev_iotlb_support);
    eval 'sub ecap_max_handle_mask {
        my($e) = @_;
	    eval q((($e >> 20) & 0xf));
    }' unless defined(&ecap_max_handle_mask);
    eval 'sub ecap_sc_support {
        my($e) = @_;
	    eval q((($e >> 7) & 0x1));
    }' unless defined(&ecap_sc_support);
    eval 'sub DMA_TLB_FLUSH_GRANU_OFFSET () {60;}' unless defined(&DMA_TLB_FLUSH_GRANU_OFFSET);
    eval 'sub DMA_TLB_GLOBAL_FLUSH () {((( &u64)1) << 60);}' unless defined(&DMA_TLB_GLOBAL_FLUSH);
    eval 'sub DMA_TLB_DSI_FLUSH () {((( &u64)2) << 60);}' unless defined(&DMA_TLB_DSI_FLUSH);
    eval 'sub DMA_TLB_PSI_FLUSH () {((( &u64)3) << 60);}' unless defined(&DMA_TLB_PSI_FLUSH);
    eval 'sub DMA_TLB_IIRG {
        my($type) = @_;
	    eval q((($type >> 60) & 7));
    }' unless defined(&DMA_TLB_IIRG);
    eval 'sub DMA_TLB_IAIG {
        my($val) = @_;
	    eval q(((($val) >> 57) & 7));
    }' unless defined(&DMA_TLB_IAIG);
    eval 'sub DMA_TLB_READ_DRAIN () {((( &u64)1) << 49);}' unless defined(&DMA_TLB_READ_DRAIN);
    eval 'sub DMA_TLB_WRITE_DRAIN () {((( &u64)1) << 48);}' unless defined(&DMA_TLB_WRITE_DRAIN);
    eval 'sub DMA_TLB_DID {
        my($id) = @_;
	    eval q(((( &u64)(($id) & 0xffff)) << 32));
    }' unless defined(&DMA_TLB_DID);
    eval 'sub DMA_TLB_IVT () {((( &u64)1) << 63);}' unless defined(&DMA_TLB_IVT);
    eval 'sub DMA_TLB_IH_NONLEAF () {((( &u64)1) << 6);}' unless defined(&DMA_TLB_IH_NONLEAF);
    eval 'sub DMA_TLB_MAX_SIZE () {(0x3f);}' unless defined(&DMA_TLB_MAX_SIZE);
    eval 'sub DMA_CCMD_INVL_GRANU_OFFSET () {61;}' unless defined(&DMA_CCMD_INVL_GRANU_OFFSET);
    eval 'sub DMA_ID_TLB_GLOBAL_FLUSH () {((( &u64)1) << 3);}' unless defined(&DMA_ID_TLB_GLOBAL_FLUSH);
    eval 'sub DMA_ID_TLB_DSI_FLUSH () {((( &u64)2) << 3);}' unless defined(&DMA_ID_TLB_DSI_FLUSH);
    eval 'sub DMA_ID_TLB_PSI_FLUSH () {((( &u64)3) << 3);}' unless defined(&DMA_ID_TLB_PSI_FLUSH);
    eval 'sub DMA_ID_TLB_READ_DRAIN () {((( &u64)1) << 7);}' unless defined(&DMA_ID_TLB_READ_DRAIN);
    eval 'sub DMA_ID_TLB_WRITE_DRAIN () {((( &u64)1) << 6);}' unless defined(&DMA_ID_TLB_WRITE_DRAIN);
    eval 'sub DMA_ID_TLB_DID {
        my($id) = @_;
	    eval q(((( &u64)(($id & 0xffff) << 16))));
    }' unless defined(&DMA_ID_TLB_DID);
    eval 'sub DMA_ID_TLB_IH_NONLEAF () {((( &u64)1) << 6);}' unless defined(&DMA_ID_TLB_IH_NONLEAF);
    eval 'sub DMA_ID_TLB_ADDR {
        my($addr) = @_;
	    eval q(($addr));
    }' unless defined(&DMA_ID_TLB_ADDR);
    eval 'sub DMA_ID_TLB_ADDR_MASK {
        my($mask) = @_;
	    eval q(($mask));
    }' unless defined(&DMA_ID_TLB_ADDR_MASK);
    eval 'sub DMA_PMEN_EPM () {((( &u32)1)<<31);}' unless defined(&DMA_PMEN_EPM);
    eval 'sub DMA_PMEN_PRS () {((( &u32)1)<<0);}' unless defined(&DMA_PMEN_PRS);
    eval 'sub DMA_GCMD_TE () {((( &u32)1) << 31);}' unless defined(&DMA_GCMD_TE);
    eval 'sub DMA_GCMD_SRTP () {((( &u32)1) << 30);}' unless defined(&DMA_GCMD_SRTP);
    eval 'sub DMA_GCMD_SFL () {((( &u32)1) << 29);}' unless defined(&DMA_GCMD_SFL);
    eval 'sub DMA_GCMD_EAFL () {((( &u32)1) << 28);}' unless defined(&DMA_GCMD_EAFL);
    eval 'sub DMA_GCMD_WBF () {((( &u32)1) << 27);}' unless defined(&DMA_GCMD_WBF);
    eval 'sub DMA_GCMD_QIE () {((( &u32)1) << 26);}' unless defined(&DMA_GCMD_QIE);
    eval 'sub DMA_GCMD_SIRTP () {((( &u32)1) << 24);}' unless defined(&DMA_GCMD_SIRTP);
    eval 'sub DMA_GCMD_IRE () {((( &u32) 1) << 25);}' unless defined(&DMA_GCMD_IRE);
    eval 'sub DMA_GCMD_CFI () {((( &u32) 1) << 23);}' unless defined(&DMA_GCMD_CFI);
    eval 'sub DMA_GSTS_TES () {((( &u32)1) << 31);}' unless defined(&DMA_GSTS_TES);
    eval 'sub DMA_GSTS_RTPS () {((( &u32)1) << 30);}' unless defined(&DMA_GSTS_RTPS);
    eval 'sub DMA_GSTS_FLS () {((( &u32)1) << 29);}' unless defined(&DMA_GSTS_FLS);
    eval 'sub DMA_GSTS_AFLS () {((( &u32)1) << 28);}' unless defined(&DMA_GSTS_AFLS);
    eval 'sub DMA_GSTS_WBFS () {((( &u32)1) << 27);}' unless defined(&DMA_GSTS_WBFS);
    eval 'sub DMA_GSTS_QIES () {((( &u32)1) << 26);}' unless defined(&DMA_GSTS_QIES);
    eval 'sub DMA_GSTS_IRTPS () {((( &u32)1) << 24);}' unless defined(&DMA_GSTS_IRTPS);
    eval 'sub DMA_GSTS_IRES () {((( &u32)1) << 25);}' unless defined(&DMA_GSTS_IRES);
    eval 'sub DMA_GSTS_CFIS () {((( &u32)1) << 23);}' unless defined(&DMA_GSTS_CFIS);
    eval 'sub DMA_CCMD_ICC () {((( &u64)1) << 63);}' unless defined(&DMA_CCMD_ICC);
    eval 'sub DMA_CCMD_GLOBAL_INVL () {((( &u64)1) << 61);}' unless defined(&DMA_CCMD_GLOBAL_INVL);
    eval 'sub DMA_CCMD_DOMAIN_INVL () {((( &u64)2) << 61);}' unless defined(&DMA_CCMD_DOMAIN_INVL);
    eval 'sub DMA_CCMD_DEVICE_INVL () {((( &u64)3) << 61);}' unless defined(&DMA_CCMD_DEVICE_INVL);
    eval 'sub DMA_CCMD_FM {
        my($m) = @_;
	    eval q(((( &u64)(($m) & 0x3)) << 32));
    }' unless defined(&DMA_CCMD_FM);
    eval 'sub DMA_CCMD_MASK_NOBIT () {0;}' unless defined(&DMA_CCMD_MASK_NOBIT);
    eval 'sub DMA_CCMD_MASK_1BIT () {1;}' unless defined(&DMA_CCMD_MASK_1BIT);
    eval 'sub DMA_CCMD_MASK_2BIT () {2;}' unless defined(&DMA_CCMD_MASK_2BIT);
    eval 'sub DMA_CCMD_MASK_3BIT () {3;}' unless defined(&DMA_CCMD_MASK_3BIT);
    eval 'sub DMA_CCMD_SID {
        my($s) = @_;
	    eval q(((( &u64)(($s) & 0xffff)) << 16));
    }' unless defined(&DMA_CCMD_SID);
    eval 'sub DMA_CCMD_DID {
        my($d) = @_;
	    eval q((( &u64)(($d) & 0xffff)));
    }' unless defined(&DMA_CCMD_DID);
    eval 'sub DMA_FECTL_IM () {((( &u32)1) << 31);}' unless defined(&DMA_FECTL_IM);
    eval 'sub DMA_FSTS_PPF () {(( &u32)2);}' unless defined(&DMA_FSTS_PPF);
    eval 'sub DMA_FSTS_PFO () {(( &u32)1);}' unless defined(&DMA_FSTS_PFO);
    eval 'sub DMA_FSTS_IQE () {(1<< 4);}' unless defined(&DMA_FSTS_IQE);
    eval 'sub DMA_FSTS_ICE () {(1<< 5);}' unless defined(&DMA_FSTS_ICE);
    eval 'sub DMA_FSTS_ITE () {(1<< 6);}' unless defined(&DMA_FSTS_ITE);
    eval 'sub dma_fsts_fault_record_index {
        my($s) = @_;
	    eval q(((($s) >> 8) & 0xff));
    }' unless defined(&dma_fsts_fault_record_index);
    eval 'sub DMA_FRCD_F () {((( &u32)1) << 31);}' unless defined(&DMA_FRCD_F);
    eval 'sub dma_frcd_type {
        my($d) = @_;
	    eval q((($d >> 30) & 1));
    }' unless defined(&dma_frcd_type);
    eval 'sub dma_frcd_fault_reason {
        my($c) = @_;
	    eval q(($c & 0xff));
    }' unless defined(&dma_frcd_fault_reason);
    eval 'sub dma_frcd_source_id {
        my($c) = @_;
	    eval q(($c & 0xffff));
    }' unless defined(&dma_frcd_source_id);
    eval 'sub dma_frcd_page_addr {
        my($d) = @_;
	    eval q(($d & ((( &u64)-1) <<  &PAGE_SHIFT)));
    }' unless defined(&dma_frcd_page_addr);
    eval 'sub IOMMU_WAIT_OP {
        my($iommu, $offset, $op, $cond, $sts) = @_;
	    eval q( &do {  &cycles_t  &start_time =  &get_cycles();  &while (1) { $sts = $op( ($iommu->{reg}) + $offset);  &if ($cond)  &break;  &if ( &DMAR_OPERATION_TIMEOUT < ( &get_cycles() -  &start_time))  &panic(\\"DMAR hardware is malfunctioning\\\\n\\");  &cpu_relax(); } }  &while (0));
    }' unless defined(&IOMMU_WAIT_OP);
    eval 'sub QI_LENGTH () {256;}' unless defined(&QI_LENGTH);
    eval("sub QI_FREE () { 0; }") unless defined(&QI_FREE);
    eval("sub QI_IN_USE () { 1; }") unless defined(&QI_IN_USE);
    eval("sub QI_DONE () { 2; }") unless defined(&QI_DONE);
    eval("sub QI_ABORT () { 3; }") unless defined(&QI_ABORT);
    eval 'sub QI_CC_TYPE () {0x1;}' unless defined(&QI_CC_TYPE);
    eval 'sub QI_IOTLB_TYPE () {0x2;}' unless defined(&QI_IOTLB_TYPE);
    eval 'sub QI_DIOTLB_TYPE () {0x3;}' unless defined(&QI_DIOTLB_TYPE);
    eval 'sub QI_IEC_TYPE () {0x4;}' unless defined(&QI_IEC_TYPE);
    eval 'sub QI_IWD_TYPE () {0x5;}' unless defined(&QI_IWD_TYPE);
    eval 'sub QI_IEC_SELECTIVE () {((( &u64)1) << 4);}' unless defined(&QI_IEC_SELECTIVE);
    eval 'sub QI_IEC_IIDEX {
        my($idx) = @_;
	    eval q(((( &u64)($idx & 0xffff) << 32)));
    }' unless defined(&QI_IEC_IIDEX);
    eval 'sub QI_IEC_IM {
        my($m) = @_;
	    eval q(((( &u64)($m & 0x1f) << 27)));
    }' unless defined(&QI_IEC_IM);
    eval 'sub QI_IWD_STATUS_DATA {
        my($d) = @_;
	    eval q(((( &u64)$d) << 32));
    }' unless defined(&QI_IWD_STATUS_DATA);
    eval 'sub QI_IWD_STATUS_WRITE () {((( &u64)1) << 5);}' unless defined(&QI_IWD_STATUS_WRITE);
    eval 'sub QI_IOTLB_DID {
        my($did) = @_;
	    eval q(((( &u64)$did) << 16));
    }' unless defined(&QI_IOTLB_DID);
    eval 'sub QI_IOTLB_DR {
        my($dr) = @_;
	    eval q(((( &u64)$dr) << 7));
    }' unless defined(&QI_IOTLB_DR);
    eval 'sub QI_IOTLB_DW {
        my($dw) = @_;
	    eval q(((( &u64)$dw) << 6));
    }' unless defined(&QI_IOTLB_DW);
    eval 'sub QI_IOTLB_GRAN {
        my($gran) = @_;
	    eval q(((( &u64)$gran) >> ( &DMA_TLB_FLUSH_GRANU_OFFSET-4)));
    }' unless defined(&QI_IOTLB_GRAN);
    eval 'sub QI_IOTLB_ADDR {
        my($addr) = @_;
	    eval q(((( &u64)$addr) &  &VTD_PAGE_MASK));
    }' unless defined(&QI_IOTLB_ADDR);
    eval 'sub QI_IOTLB_IH {
        my($ih) = @_;
	    eval q(((( &u64)$ih) << 6));
    }' unless defined(&QI_IOTLB_IH);
    eval 'sub QI_IOTLB_AM {
        my($am) = @_;
	    eval q(((( &u8)$am)));
    }' unless defined(&QI_IOTLB_AM);
    eval 'sub QI_CC_FM {
        my($fm) = @_;
	    eval q(((( &u64)$fm) << 48));
    }' unless defined(&QI_CC_FM);
    eval 'sub QI_CC_SID {
        my($sid) = @_;
	    eval q(((( &u64)$sid) << 32));
    }' unless defined(&QI_CC_SID);
    eval 'sub QI_CC_DID {
        my($did) = @_;
	    eval q(((( &u64)$did) << 16));
    }' unless defined(&QI_CC_DID);
    eval 'sub QI_CC_GRAN {
        my($gran) = @_;
	    eval q(((( &u64)$gran) >> ( &DMA_CCMD_INVL_GRANU_OFFSET-4)));
    }' unless defined(&QI_CC_GRAN);
    eval 'sub QI_DEV_IOTLB_SID {
        my($sid) = @_;
	    eval q((( &u64)(($sid) & 0xffff) << 32));
    }' unless defined(&QI_DEV_IOTLB_SID);
    eval 'sub QI_DEV_IOTLB_QDEP {
        my($qdep) = @_;
	    eval q(((($qdep) & 0x1f) << 16));
    }' unless defined(&QI_DEV_IOTLB_QDEP);
    eval 'sub QI_DEV_IOTLB_ADDR {
        my($addr) = @_;
	    eval q((( &u64)($addr) &  &VTD_PAGE_MASK));
    }' unless defined(&QI_DEV_IOTLB_ADDR);
    eval 'sub QI_DEV_IOTLB_SIZE () {1;}' unless defined(&QI_DEV_IOTLB_SIZE);
    eval 'sub QI_DEV_IOTLB_MAX_INVS () {32;}' unless defined(&QI_DEV_IOTLB_MAX_INVS);
    if(defined(&CONFIG_INTR_REMAP)) {
	eval 'sub INTR_REMAP_PAGE_ORDER () {8;}' unless defined(&INTR_REMAP_PAGE_ORDER);
	eval 'sub INTR_REMAP_TABLE_REG_SIZE () {0xf;}' unless defined(&INTR_REMAP_TABLE_REG_SIZE);
	eval 'sub INTR_REMAP_TABLE_ENTRIES () {65536;}' unless defined(&INTR_REMAP_TABLE_ENTRIES);
    }
    eval("sub SR_DMAR_FECTL_REG () { 0; }") unless defined(&SR_DMAR_FECTL_REG);
    eval("sub SR_DMAR_FEDATA_REG () { 1; }") unless defined(&SR_DMAR_FEDATA_REG);
    eval("sub SR_DMAR_FEADDR_REG () { 2; }") unless defined(&SR_DMAR_FEADDR_REG);
    eval("sub SR_DMAR_FEUADDR_REG () { 3; }") unless defined(&SR_DMAR_FEUADDR_REG);
    eval("sub MAX_SR_DMAR_REGS () { 4; }") unless defined(&MAX_SR_DMAR_REGS);
    if(defined(&CONFIG_DMAR)) {
    }
    if(defined(&CONFIG_INTR_REMAP)) {
    }
    eval 'sub __iommu_flush_cache {
        my($iommu,$addr,$size) = @_;
	    eval q({  &if (! &ecap_coherent( ($iommu->{ecap})))  &clflush_cache_range($addr, $size); });
    }' unless defined(&__iommu_flush_cache);
}
1;
