require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_NCRYPTO_H)) {
    eval 'sub _LINUX_NCRYPTO_H () {1;}' unless defined(&_LINUX_NCRYPTO_H);
    require 'asm/atomic.ph';
    require 'linux/crypto.ph';
    require 'linux/kernel.ph';
    require 'linux/list.ph';
    require 'linux/scatterlist.ph';
    require 'linux/slab.ph';
    eval 'sub NCRYPTO_ALG_TYPE_MASK () {0xf;}' unless defined(&NCRYPTO_ALG_TYPE_MASK);
    eval 'sub NCRYPTO_ALG_TYPE_CIPHER () {0x1;}' unless defined(&NCRYPTO_ALG_TYPE_CIPHER);
    eval 'sub NCRYPTO_ALG_TYPE_DIGEST () {0x2;}' unless defined(&NCRYPTO_ALG_TYPE_DIGEST);
    eval 'sub NCRYPTO_ALG_TYPE_HASH () {0x3;}' unless defined(&NCRYPTO_ALG_TYPE_HASH);
    eval 'sub NCRYPTO_ALG_TYPE_BLKCIPHER () {0x4;}' unless defined(&NCRYPTO_ALG_TYPE_BLKCIPHER);
    eval 'sub NCRYPTO_ALG_TYPE_ABLKCIPHER () {0x5;}' unless defined(&NCRYPTO_ALG_TYPE_ABLKCIPHER);
    eval 'sub NCRYPTO_ALG_TYPE_GIVCIPHER () {0x6;}' unless defined(&NCRYPTO_ALG_TYPE_GIVCIPHER);
    eval 'sub NCRYPTO_ALG_TYPE_COMPRESS () {0x8;}' unless defined(&NCRYPTO_ALG_TYPE_COMPRESS);
    eval 'sub NCRYPTO_ALG_TYPE_AEAD () {0x9;}' unless defined(&NCRYPTO_ALG_TYPE_AEAD);
    eval 'sub NCRYPTO_ALG_TYPE_HASH_MASK () {0xe;}' unless defined(&NCRYPTO_ALG_TYPE_HASH_MASK);
    eval 'sub NCRYPTO_ALG_TYPE_BLKCIPHER_MASK () {0xc;}' unless defined(&NCRYPTO_ALG_TYPE_BLKCIPHER_MASK);
    eval 'sub NCRYPTO_ALG_LARVAL () {0x10;}' unless defined(&NCRYPTO_ALG_LARVAL);
    eval 'sub NCRYPTO_ALG_DEAD () {0x20;}' unless defined(&NCRYPTO_ALG_DEAD);
    eval 'sub NCRYPTO_ALG_DYING () {0x40;}' unless defined(&NCRYPTO_ALG_DYING);
    eval 'sub NCRYPTO_ALG_ASYNC () {0x80;}' unless defined(&NCRYPTO_ALG_ASYNC);
    eval 'sub NCRYPTO_ALG_NEED_FALLBACK () {0x100;}' unless defined(&NCRYPTO_ALG_NEED_FALLBACK);
    eval 'sub NCRYPTO_ALG_GENIV () {0x200;}' unless defined(&NCRYPTO_ALG_GENIV);
    eval 'sub NCRYPTO_ALG_TESTED () {0x400;}' unless defined(&NCRYPTO_ALG_TESTED);
    if(defined( &ARCH_KMALLOC_MINALIGN)) {
	eval 'sub CRYPTO_MINALIGN () { &ARCH_KMALLOC_MINALIGN;}' unless defined(&CRYPTO_MINALIGN);
    }
 elsif(defined( &ARCH_SLAB_MINALIGN)) {
	eval 'sub CRYPTO_MINALIGN () { &ARCH_SLAB_MINALIGN;}' unless defined(&CRYPTO_MINALIGN);
    } else {
	eval 'sub CRYPTO_MINALIGN () { &__alignof__;}' unless defined(&CRYPTO_MINALIGN);
    }
    if(defined(&CRYPTO_MINALIGN)) {
	eval 'sub CRYPTO_MINALIGN_ATTR () { &__attribute__ (( &__aligned__( &CRYPTO_MINALIGN)));}' unless defined(&CRYPTO_MINALIGN_ATTR);
    } else {
	eval 'sub CRYPTO_MINALIGN_ATTR () {1;}' unless defined(&CRYPTO_MINALIGN_ATTR);
    }
    unless(defined(&PTR_ALIGN)) {
	eval 'sub PTR_ALIGN {
	    my($p, $a) = @_;
    	    eval q((( &typeof) &ALIGN(($p), ($a))));
	}' unless defined(&PTR_ALIGN);
    }
    unless(defined(&IS_ALIGNED)) {
	eval 'sub IS_ALIGNED {
	    my($x,$a) = @_;
    	    eval q(((($x) % (( &typeof($x))($a))) == 0));
	}' unless defined(&IS_ALIGNED);
    }
    eval 'sub cra_ablkcipher () { ($cra_u->{ablkcipher});}' unless defined(&cra_ablkcipher);
    eval 'sub cra_aead () { ($cra_u->{aead});}' unless defined(&cra_aead);
    eval 'sub cra_blkcipher () { ($cra_u->{blkcipher});}' unless defined(&cra_blkcipher);
    eval 'sub cra_hash () { ($cra_u->{hash});}' unless defined(&cra_hash);
    if(defined(&CONFIG_CRYPTO)) {
    } else {
	eval 'sub crypto_has_alg {
	    my($name,$type,$mask) = @_;
    	    eval q({ 0; });
	}' unless defined(&crypto_has_alg);
    }
    eval 'sub crt_ablkcipher () { ($crt_u->{ablkcipher});}' unless defined(&crt_ablkcipher);
    eval 'sub crt_aead () { ($crt_u->{aead});}' unless defined(&crt_aead);
    eval 'sub crt_blkcipher () { ($crt_u->{blkcipher});}' unless defined(&crt_blkcipher);
    eval 'sub crt_hash () { ($crt_u->{hash});}' unless defined(&crt_hash);
    eval 'sub crypto_cipher () { &crypto_tfm;}' unless defined(&crypto_cipher);
    eval("sub CRYPTOA_UNSPEC () { 0; }") unless defined(&CRYPTOA_UNSPEC);
    eval("sub CRYPTOA_ALG () { 1; }") unless defined(&CRYPTOA_ALG);
    eval("sub CRYPTOA_TYPE () { 2; }") unless defined(&CRYPTOA_TYPE);
    eval("sub CRYPTOA_U32 () { 3; }") unless defined(&CRYPTOA_U32);
    eval("sub __CRYPTOA_MAX () { 4; }") unless defined(&__CRYPTOA_MAX);
    eval 'sub CRYPTOA_MAX () {( &__CRYPTOA_MAX - 1);}' unless defined(&CRYPTOA_MAX);
    eval 'sub CRYPTO_MAX_ATTRS () {32;}' unless defined(&CRYPTO_MAX_ATTRS);
    eval 'sub sg_set_page {
        my($sg,$page,$len,$offset) = @_;
	    eval q({  ($sg->{page}) = $page;  ($sg->{offset}) = $offset;  ($sg->{length}) = $len; });
    }' unless defined(&sg_set_page);
    eval 'sub sg_page {
        my($sg) = @_;
	    eval q((($sg)-> &page));
    }' unless defined(&sg_page);
    eval 'sub sg_mark_end {
        my($sg) = @_;
	    eval q({ });
    }' unless defined(&sg_mark_end);
    eval 'sub sg_init_table {
        my($sgl,$nents) = @_;
	    eval q({  &memset($sgl, 0, $sizeof{$sgl} * $nents); });
    }' unless defined(&sg_init_table);
    eval 'sub char {
        eval q(* &ncrypto_tfm_alg_driver_name(\'struct ncrypto_tfm\' * &tfm) {  ($tfm->{__crt_alg}->{cra_driver_name}); });
    }' unless defined(&char);
    eval 'sub ncrypto_tfm_alg_priority {
        my($tfm) = @_;
	    eval q({  ($tfm->{__crt_alg}->{cra_priority}); });
    }' unless defined(&ncrypto_tfm_alg_priority);
    eval 'sub ncrypto_tfm_alg_type {
        my($tfm) = @_;
	    eval q({  ($tfm->{__crt_alg}->{cra_flags}) &  &NCRYPTO_ALG_TYPE_MASK; });
    }' unless defined(&ncrypto_tfm_alg_type);
    eval 'sub ncrypto_tfm_alg_blocksize {
        my($tfm) = @_;
	    eval q({  ($tfm->{__crt_alg}->{cra_blocksize}); });
    }' unless defined(&ncrypto_tfm_alg_blocksize);
    eval 'sub ncrypto_tfm_alg_alignmask {
        my($tfm) = @_;
	    eval q({  ($tfm->{__crt_alg}->{cra_alignmask}); });
    }' unless defined(&ncrypto_tfm_alg_alignmask);
    eval 'sub crypto_tfm_get_flags {
        my($tfm) = @_;
	    eval q({  ($tfm->{crt_flags}); });
    }' unless defined(&crypto_tfm_get_flags);
    eval 'sub ncrypto_tfm_get_flags {
        my($tfm) = @_;
	    eval q({  ($tfm->{crt_flags}); });
    }' unless defined(&ncrypto_tfm_get_flags);
    eval 'sub crypto_tfm_set_flags {
        my($tfm,$flags) = @_;
	    eval q({  ($tfm->{crt_flags}) |= $flags; });
    }' unless defined(&crypto_tfm_set_flags);
    eval 'sub ncrypto_tfm_set_flags {
        my($tfm,$flags) = @_;
	    eval q({  ($tfm->{crt_flags}) |= $flags; });
    }' unless defined(&ncrypto_tfm_set_flags);
    eval 'sub crypto_tfm_clear_flags {
        my($tfm,$flags) = @_;
	    eval q({  ($tfm->{crt_flags}) &= ~$flags; });
    }' unless defined(&crypto_tfm_clear_flags);
    eval 'sub ncrypto_tfm_clear_flags {
        my($tfm,$flags) = @_;
	    eval q({  ($tfm->{crt_flags}) &= ~$flags; });
    }' unless defined(&ncrypto_tfm_clear_flags);
    eval 'sub void {
        eval q(* &ncrypto_tfm_ctx(\'struct ncrypto_tfm\' * &tfm) {  ($tfm->{__crt_ctx}); });
    }' unless defined(&void);
    eval 'sub ncrypto_tfm_ctx_alignment {
        my($void) = @_;
	    eval q({ \'struct ncrypto_tfm\' * &tfm;  &__alignof__( ($tfm->{__crt_ctx})); });
    }' unless defined(&ncrypto_tfm_ctx_alignment);
    eval 'sub crypto_skcipher_type {
        my($type) = @_;
	    eval q({ $type &= ~( &NCRYPTO_ALG_TYPE_MASK |  &NCRYPTO_ALG_GENIV); $type |=  &NCRYPTO_ALG_TYPE_BLKCIPHER; $type; });
    }' unless defined(&crypto_skcipher_type);
    eval 'sub crypto_skcipher_mask {
        my($mask) = @_;
	    eval q({ $mask &= ~( &NCRYPTO_ALG_TYPE_MASK |  &NCRYPTO_ALG_GENIV); $mask |=  &NCRYPTO_ALG_TYPE_BLKCIPHER_MASK; $mask; });
    }' unless defined(&crypto_skcipher_mask);
    eval 'sub ncrypto_tfm {
        eval q(* &crypto_ablkcipher_tfm( \'struct crypto_ablkcipher\' * &tfm) {  ($tfm->{base}); });
    }' unless defined(&ncrypto_tfm);
    eval 'sub crypto_free_ablkcipher {
        my($tfm) = @_;
	    eval q({  &ncrypto_free_tfm( &crypto_ablkcipher_tfm($tfm)); });
    }' unless defined(&crypto_free_ablkcipher);
    eval 'sub crypto_has_ablkcipher {
        my($alg_name,$type,$mask) = @_;
	    eval q({  &crypto_has_alg($alg_name,  &crypto_skcipher_type($type),  &crypto_skcipher_mask($mask)); });
    }' unless defined(&crypto_has_ablkcipher);
    eval 'sub ablkcipher_tfm {
        eval q(* &crypto_ablkcipher_crt( \'struct crypto_ablkcipher\' * &tfm) {  &crypto_ablkcipher_tfm( &tfm)-> &crt_ablkcipher; });
    }' unless defined(&ablkcipher_tfm);
    eval 'sub crypto_ablkcipher_ivsize {
        my($tfm) = @_;
	    eval q({  &crypto_ablkcipher_crt($tfm)-> &ivsize; });
    }' unless defined(&crypto_ablkcipher_ivsize);
    eval 'sub crypto_ablkcipher_blocksize {
        my($tfm) = @_;
	    eval q({  &ncrypto_tfm_alg_blocksize( &crypto_ablkcipher_tfm($tfm)); });
    }' unless defined(&crypto_ablkcipher_blocksize);
    eval 'sub crypto_ablkcipher_alignmask {
        my($tfm) = @_;
	    eval q({  &ncrypto_tfm_alg_alignmask( &crypto_ablkcipher_tfm($tfm)); });
    }' unless defined(&crypto_ablkcipher_alignmask);
    eval 'sub crypto_ablkcipher_get_flags {
        my($tfm) = @_;
	    eval q({  &ncrypto_tfm_get_flags( &crypto_ablkcipher_tfm($tfm)); });
    }' unless defined(&crypto_ablkcipher_get_flags);
    eval 'sub crypto_ablkcipher_set_flags {
        my($tfm,$flags) = @_;
	    eval q({  &ncrypto_tfm_set_flags( &crypto_ablkcipher_tfm($tfm), $flags); });
    }' unless defined(&crypto_ablkcipher_set_flags);
    eval 'sub crypto_ablkcipher_clear_flags {
        my($tfm,$flags) = @_;
	    eval q({  &ncrypto_tfm_clear_flags( &crypto_ablkcipher_tfm($tfm), $flags); });
    }' unless defined(&crypto_ablkcipher_clear_flags);
    eval 'sub crypto_ablkcipher_setkey {
        my($tfm,$key,$keylen) = @_;
	    eval q({ \'struct ablkcipher_tfm\' * &crt =  &crypto_ablkcipher_crt($tfm);  ($crt->{setkey})( ($crt->{base}), $key, $keylen); });
    }' unless defined(&crypto_ablkcipher_setkey);
    eval 'sub crypto_ablkcipher {
        eval q(* &crypto_ablkcipher_reqtfm( \'struct ablkcipher_request\' * &req) {  &__crypto_ablkcipher_cast( ($req->{base}->{tfm})); });
    }' unless defined(&crypto_ablkcipher);
    eval 'sub crypto_ablkcipher_encrypt {
        my($req) = @_;
	    eval q({ \'struct ablkcipher_tfm\' * &crt =  &crypto_ablkcipher_crt( &crypto_ablkcipher_reqtfm($req));  ($crt->{encrypt})($req); });
    }' unless defined(&crypto_ablkcipher_encrypt);
    eval 'sub crypto_ablkcipher_decrypt {
        my($req) = @_;
	    eval q({ \'struct ablkcipher_tfm\' * &crt =  &crypto_ablkcipher_crt( &crypto_ablkcipher_reqtfm($req));  ($crt->{decrypt})($req); });
    }' unless defined(&crypto_ablkcipher_decrypt);
    eval 'sub crypto_ablkcipher_reqsize {
        my($tfm) = @_;
	    eval q({  &crypto_ablkcipher_crt($tfm)-> &reqsize; });
    }' unless defined(&crypto_ablkcipher_reqsize);
    eval 'sub ablkcipher_request_set_tfm {
        my($req,$tfm) = @_;
	    eval q({  ($req->{base}->{tfm}) =  &crypto_ablkcipher_tfm( &crypto_ablkcipher_crt($tfm)-> &base); });
    }' unless defined(&ablkcipher_request_set_tfm);
    eval 'sub ablkcipher_request {
        eval q(* &ablkcipher_request_cast( \'struct crypto_async_request\' * &req) {  &container_of( &req, \'struct ablkcipher_request\',  &base); });
    }' unless defined(&ablkcipher_request);
    eval 'sub ablkcipher_request {
        eval q(* &ablkcipher_request_alloc( \'struct crypto_ablkcipher\' * &tfm,  &gfp_t  &gfp) { \'struct ablkcipher_request\' * &req;  &req =  &kmalloc($sizeof{\'struct ablkcipher_request\'} +  &crypto_ablkcipher_reqsize( &tfm),  &gfp);  &if ( &likely( &req))  &ablkcipher_request_set_tfm( &req,  &tfm);  &req; });
    }' unless defined(&ablkcipher_request);
    eval 'sub ablkcipher_request_free {
        my($req) = @_;
	    eval q({  &kfree($req); });
    }' unless defined(&ablkcipher_request_free);
    eval 'sub ablkcipher_request_set_callback {
        my($req,$flags,$complete,$data) = @_;
	    eval q({  ($req->{base}->{complete}) = $complete;  ($req->{base}->{data}) = $data;  ($req->{base}->{flags}) = $flags; });
    }' unless defined(&ablkcipher_request_set_callback);
    eval 'sub ablkcipher_request_set_crypt {
        my($req,$src,$dst,$nbytes,$iv) = @_;
	    eval q({  ($req->{src}) = $src;  ($req->{dst}) = $dst;  ($req->{nbytes}) = $nbytes;  ($req->{info}) = $iv; });
    }' unless defined(&ablkcipher_request_set_crypt);
    eval 'sub crypto_aead {
        eval q(* &__crypto_aead_cast(\'struct ncrypto_tfm\' * &tfm) {  &tfm; });
    }' unless defined(&crypto_aead);
    eval 'sub ncrypto_tfm {
        eval q(* &crypto_aead_tfm(\'struct crypto_aead\' * &tfm) {  ($tfm->{base}); });
    }' unless defined(&ncrypto_tfm);
    eval 'sub crypto_free_aead {
        my($tfm) = @_;
	    eval q({  &ncrypto_free_tfm( &crypto_aead_tfm($tfm)); });
    }' unless defined(&crypto_free_aead);
    eval 'sub aead_tfm {
        eval q(* &crypto_aead_crt(\'struct crypto_aead\' * &tfm) {  &crypto_aead_tfm( &tfm)-> &crt_aead; });
    }' unless defined(&aead_tfm);
    eval 'sub crypto_aead_ivsize {
        my($tfm) = @_;
	    eval q({  &crypto_aead_crt($tfm)-> &ivsize; });
    }' unless defined(&crypto_aead_ivsize);
    eval 'sub crypto_aead_authsize {
        my($tfm) = @_;
	    eval q({  &crypto_aead_crt($tfm)-> &authsize; });
    }' unless defined(&crypto_aead_authsize);
    eval 'sub crypto_aead_blocksize {
        my($tfm) = @_;
	    eval q({  &ncrypto_tfm_alg_blocksize( &crypto_aead_tfm($tfm)); });
    }' unless defined(&crypto_aead_blocksize);
    eval 'sub crypto_aead_alignmask {
        my($tfm) = @_;
	    eval q({  &ncrypto_tfm_alg_alignmask( &crypto_aead_tfm($tfm)); });
    }' unless defined(&crypto_aead_alignmask);
    eval 'sub crypto_aead_get_flags {
        my($tfm) = @_;
	    eval q({  &ncrypto_tfm_get_flags( &crypto_aead_tfm($tfm)); });
    }' unless defined(&crypto_aead_get_flags);
    eval 'sub crypto_aead_set_flags {
        my($tfm,$flags) = @_;
	    eval q({  &ncrypto_tfm_set_flags( &crypto_aead_tfm($tfm), $flags); });
    }' unless defined(&crypto_aead_set_flags);
    eval 'sub crypto_aead_clear_flags {
        my($tfm,$flags) = @_;
	    eval q({  &ncrypto_tfm_clear_flags( &crypto_aead_tfm($tfm), $flags); });
    }' unless defined(&crypto_aead_clear_flags);
    eval 'sub crypto_aead_setkey {
        my($tfm,$key,$keylen) = @_;
	    eval q({ \'struct aead_tfm\' * &crt =  &crypto_aead_crt($tfm);  ($crt->{setkey})( ($crt->{base}), $key, $keylen); });
    }' unless defined(&crypto_aead_setkey);
    eval 'sub crypto_aead {
        eval q(* &crypto_aead_reqtfm(\'struct aead_request\' * &req) {  &__crypto_aead_cast( ($req->{base}->{tfm})); });
    }' unless defined(&crypto_aead);
    eval 'sub crypto_aead_encrypt {
        my($req) = @_;
	    eval q({  &crypto_aead_crt( &crypto_aead_reqtfm($req))-> &encrypt($req); });
    }' unless defined(&crypto_aead_encrypt);
    eval 'sub crypto_aead_decrypt {
        my($req) = @_;
	    eval q({  &crypto_aead_crt( &crypto_aead_reqtfm($req))-> &decrypt($req); });
    }' unless defined(&crypto_aead_decrypt);
    eval 'sub crypto_aead_reqsize {
        my($tfm) = @_;
	    eval q({  &crypto_aead_crt($tfm)-> &reqsize; });
    }' unless defined(&crypto_aead_reqsize);
    eval 'sub aead_request_set_tfm {
        my($req,$tfm) = @_;
	    eval q({  ($req->{base}->{tfm}) =  &crypto_aead_tfm( &crypto_aead_crt($tfm)-> &base); });
    }' unless defined(&aead_request_set_tfm);
    eval 'sub aead_request {
        eval q(* &aead_request_alloc(\'struct crypto_aead\' * &tfm,  &gfp_t  &gfp) { \'struct aead_request\' * &req;  &req =  &kmalloc($sizeof{ &req} +  &crypto_aead_reqsize( &tfm),  &gfp);  &if ( &likely( &req))  &aead_request_set_tfm( &req,  &tfm);  &req; });
    }' unless defined(&aead_request);
    eval 'sub aead_request_free {
        my($req) = @_;
	    eval q({  &kfree($req); });
    }' unless defined(&aead_request_free);
    eval 'sub aead_request_set_callback {
        my($req,$flags,$complete,$data) = @_;
	    eval q({  ($req->{base}->{complete}) = $complete;  ($req->{base}->{data}) = $data;  ($req->{base}->{flags}) = $flags; });
    }' unless defined(&aead_request_set_callback);
    eval 'sub aead_request_set_crypt {
        my($req,$src,$dst,$cryptlen,$iv) = @_;
	    eval q({  ($req->{src}) = $src;  ($req->{dst}) = $dst;  ($req->{cryptlen}) = $cryptlen;  ($req->{iv}) = $iv; });
    }' unless defined(&aead_request_set_crypt);
    eval 'sub aead_request_set_assoc {
        my($req,$assoc,$assoclen) = @_;
	    eval q({  ($req->{assoc}) = $assoc;  ($req->{assoclen}) = $assoclen; });
    }' unless defined(&aead_request_set_assoc);
    eval 'sub crypto_blkcipher {
        eval q(* &__crypto_blkcipher_cast( \'struct ncrypto_tfm\' * &tfm) {  &tfm; });
    }' unless defined(&crypto_blkcipher);
    eval 'sub crypto_blkcipher {
        eval q(* &crypto_blkcipher_cast( \'struct ncrypto_tfm\' * &tfm) {  &BUG_ON( &ncrypto_tfm_alg_type( &tfm) !=  &NCRYPTO_ALG_TYPE_BLKCIPHER);  &__crypto_blkcipher_cast( &tfm); });
    }' unless defined(&crypto_blkcipher);
    eval 'sub crypto_blkcipher {
        eval q(* &crypto_alloc_blkcipher(  &const \'char\' * &alg_name,  &u32  &type,  &u32  &mask) {  &type &= ~ &NCRYPTO_ALG_TYPE_MASK;  &type |=  &NCRYPTO_ALG_TYPE_BLKCIPHER;  &mask |=  &NCRYPTO_ALG_TYPE_MASK;  &__crypto_blkcipher_cast( &crypto_alloc_base( &alg_name,  &type,  &mask)); });
    }' unless defined(&crypto_blkcipher);
    eval 'sub ncrypto_tfm {
        eval q(* &crypto_blkcipher_tfm( \'struct crypto_blkcipher\' * &tfm) {  ($tfm->{base}); });
    }' unless defined(&ncrypto_tfm);
    eval 'sub crypto_free_blkcipher {
        my($tfm) = @_;
	    eval q({  &ncrypto_free_tfm( &crypto_blkcipher_tfm($tfm)); });
    }' unless defined(&crypto_free_blkcipher);
    eval 'sub crypto_has_blkcipher {
        my($alg_name,$type,$mask) = @_;
	    eval q({ $type &= ~ &NCRYPTO_ALG_TYPE_MASK; $type |=  &NCRYPTO_ALG_TYPE_BLKCIPHER; $mask |=  &NCRYPTO_ALG_TYPE_MASK;  &crypto_has_alg($alg_name, $type, $mask); });
    }' unless defined(&crypto_has_blkcipher);
    eval 'sub char {
        eval q(* &crypto_blkcipher_name(\'struct crypto_blkcipher\' * &tfm) {  &ncrypto_tfm_alg_name( &crypto_blkcipher_tfm( &tfm)); });
    }' unless defined(&char);
    eval 'sub blkcipher_tfm {
        eval q(* &crypto_blkcipher_crt( \'struct crypto_blkcipher\' * &tfm) {  &crypto_blkcipher_tfm( &tfm)-> &crt_blkcipher; });
    }' unless defined(&blkcipher_tfm);
    eval 'sub blkcipher_alg {
        eval q(* &crypto_blkcipher_alg( \'struct crypto_blkcipher\' * &tfm) {  &crypto_blkcipher_tfm( &tfm)-> ($__crt_alg->{cra_blkcipher}); });
    }' unless defined(&blkcipher_alg);
    eval 'sub crypto_blkcipher_ivsize {
        my($tfm) = @_;
	    eval q({  &crypto_blkcipher_alg($tfm)-> &ivsize; });
    }' unless defined(&crypto_blkcipher_ivsize);
    eval 'sub crypto_blkcipher_blocksize {
        my($tfm) = @_;
	    eval q({  &ncrypto_tfm_alg_blocksize( &crypto_blkcipher_tfm($tfm)); });
    }' unless defined(&crypto_blkcipher_blocksize);
    eval 'sub crypto_blkcipher_alignmask {
        my($tfm) = @_;
	    eval q({  &ncrypto_tfm_alg_alignmask( &crypto_blkcipher_tfm($tfm)); });
    }' unless defined(&crypto_blkcipher_alignmask);
    eval 'sub crypto_blkcipher_get_flags {
        my($tfm) = @_;
	    eval q({  &ncrypto_tfm_get_flags( &crypto_blkcipher_tfm($tfm)); });
    }' unless defined(&crypto_blkcipher_get_flags);
    eval 'sub crypto_blkcipher_set_flags {
        my($tfm,$flags) = @_;
	    eval q({  &ncrypto_tfm_set_flags( &crypto_blkcipher_tfm($tfm), $flags); });
    }' unless defined(&crypto_blkcipher_set_flags);
    eval 'sub crypto_blkcipher_clear_flags {
        my($tfm,$flags) = @_;
	    eval q({  &ncrypto_tfm_clear_flags( &crypto_blkcipher_tfm($tfm), $flags); });
    }' unless defined(&crypto_blkcipher_clear_flags);
    eval 'sub crypto_blkcipher_setkey {
        my($tfm,$key,$keylen) = @_;
	    eval q({  &crypto_blkcipher_crt($tfm)-> &setkey( &crypto_blkcipher_tfm($tfm), $key, $keylen); });
    }' unless defined(&crypto_blkcipher_setkey);
    eval 'sub crypto_blkcipher_encrypt {
        my($desc,$dst,$src,$nbytes) = @_;
	    eval q({  ($desc->{info}) =  &crypto_blkcipher_crt( ($desc->{tfm}))-> &iv;  &crypto_blkcipher_crt( ($desc->{tfm}))-> &encrypt($desc, $dst, $src, $nbytes); });
    }' unless defined(&crypto_blkcipher_encrypt);
    eval 'sub crypto_blkcipher_encrypt_iv {
        my($desc,$dst,$src,$nbytes) = @_;
	    eval q({  &crypto_blkcipher_crt( ($desc->{tfm}))-> &encrypt($desc, $dst, $src, $nbytes); });
    }' unless defined(&crypto_blkcipher_encrypt_iv);
    eval 'sub crypto_blkcipher_decrypt {
        my($desc,$dst,$src,$nbytes) = @_;
	    eval q({  ($desc->{info}) =  &crypto_blkcipher_crt( ($desc->{tfm}))-> &iv;  &crypto_blkcipher_crt( ($desc->{tfm}))-> &decrypt($desc, $dst, $src, $nbytes); });
    }' unless defined(&crypto_blkcipher_decrypt);
    eval 'sub crypto_blkcipher_decrypt_iv {
        my($desc,$dst,$src,$nbytes) = @_;
	    eval q({  &crypto_blkcipher_crt( ($desc->{tfm}))-> &decrypt($desc, $dst, $src, $nbytes); });
    }' unless defined(&crypto_blkcipher_decrypt_iv);
    eval 'sub crypto_blkcipher_set_iv {
        my($tfm,$src,$len) = @_;
	    eval q({  &memcpy( &crypto_blkcipher_crt($tfm)-> &iv, $src, $len); });
    }' unless defined(&crypto_blkcipher_set_iv);
    eval 'sub crypto_blkcipher_get_iv {
        my($tfm,$dst,$len) = @_;
	    eval q({  &memcpy($dst,  &crypto_blkcipher_crt($tfm)-> &iv, $len); });
    }' unless defined(&crypto_blkcipher_get_iv);
    eval 'sub crypto_cipher {
        eval q(* &__crypto_cipher_cast(\'struct crypto_tfm\' * &tfm) {  &tfm; });
    }' unless defined(&crypto_cipher);
    eval 'sub crypto_cipher {
        eval q(* &crypto_cipher_cast(\'struct crypto_tfm\' * &tfm) {  &BUG_ON( &crypto_tfm_alg_type( &tfm) !=  &CRYPTO_ALG_TYPE_CIPHER);  &__crypto_cipher_cast( &tfm); });
    }' unless defined(&crypto_cipher);
    eval 'sub crypto_tfm {
        eval q(* &crypto_cipher_tfm(\'struct crypto_cipher\' * &tfm) {  &tfm; });
    }' unless defined(&crypto_tfm);
    eval 'sub crypto_free_cipher {
        my($tfm) = @_;
	    eval q({  &crypto_free_tfm( &crypto_cipher_tfm($tfm)); });
    }' unless defined(&crypto_free_cipher);
    eval 'sub cipher_tfm {
        eval q(* &crypto_cipher_crt(\'struct crypto_cipher\' * &tfm) {  &crypto_cipher_tfm( &tfm)-> &crt_cipher; });
    }' unless defined(&cipher_tfm);
    eval 'sub crypto_cipher_blocksize {
        my($tfm) = @_;
	    eval q({  &crypto_tfm_alg_blocksize( &crypto_cipher_tfm($tfm)); });
    }' unless defined(&crypto_cipher_blocksize);
    eval 'sub crypto_cipher_alignmask {
        my($tfm) = @_;
	    eval q({  &crypto_tfm_alg_alignmask( &crypto_cipher_tfm($tfm)); });
    }' unless defined(&crypto_cipher_alignmask);
    eval 'sub crypto_cipher_get_flags {
        my($tfm) = @_;
	    eval q({  &crypto_tfm_get_flags( &crypto_cipher_tfm($tfm)); });
    }' unless defined(&crypto_cipher_get_flags);
    eval 'sub crypto_cipher_set_flags {
        my($tfm,$flags) = @_;
	    eval q({  &crypto_tfm_set_flags( &crypto_cipher_tfm($tfm), $flags); });
    }' unless defined(&crypto_cipher_set_flags);
    eval 'sub crypto_cipher_clear_flags {
        my($tfm,$flags) = @_;
	    eval q({  &crypto_tfm_clear_flags( &crypto_cipher_tfm($tfm), $flags); });
    }' unless defined(&crypto_cipher_clear_flags);
    eval 'sub crypto_hash {
        eval q(* &__crypto_hash_cast(\'struct ncrypto_tfm\' * &tfm) {  &tfm; });
    }' unless defined(&crypto_hash);
    eval 'sub crypto_hash {
        eval q(* &crypto_hash_cast(\'struct ncrypto_tfm\' * &tfm) {  &BUG_ON(( &ncrypto_tfm_alg_type( &tfm) ^  &NCRYPTO_ALG_TYPE_HASH) &  &NCRYPTO_ALG_TYPE_HASH_MASK);  &__crypto_hash_cast( &tfm); });
    }' unless defined(&crypto_hash);
    eval 'sub crypto_hash {
        eval q(* &crypto_alloc_hash( &const \'char\' * &alg_name,  &u32  &type,  &u32  &mask) {  &type &= ~ &NCRYPTO_ALG_TYPE_MASK;  &mask &= ~ &NCRYPTO_ALG_TYPE_MASK;  &type |=  &NCRYPTO_ALG_TYPE_HASH;  &mask |=  &NCRYPTO_ALG_TYPE_HASH_MASK;  &__crypto_hash_cast( &crypto_alloc_base( &alg_name,  &type,  &mask)); });
    }' unless defined(&crypto_hash);
    eval 'sub ncrypto_tfm {
        eval q(* &crypto_hash_tfm(\'struct crypto_hash\' * &tfm) {  ($tfm->{base}); });
    }' unless defined(&ncrypto_tfm);
    eval 'sub crypto_free_hash {
        my($tfm) = @_;
	    eval q({  &ncrypto_free_tfm( &crypto_hash_tfm($tfm)); });
    }' unless defined(&crypto_free_hash);
    eval 'sub crypto_has_hash {
        my($alg_name,$type,$mask) = @_;
	    eval q({ $type &= ~ &NCRYPTO_ALG_TYPE_MASK; $mask &= ~ &NCRYPTO_ALG_TYPE_MASK; $type |=  &NCRYPTO_ALG_TYPE_HASH; $mask |=  &NCRYPTO_ALG_TYPE_HASH_MASK;  &crypto_has_alg($alg_name, $type, $mask); });
    }' unless defined(&crypto_has_hash);
    eval 'sub hash_tfm {
        eval q(* &crypto_hash_crt(\'struct crypto_hash\' * &tfm) {  &crypto_hash_tfm( &tfm)-> &crt_hash; });
    }' unless defined(&hash_tfm);
    eval 'sub crypto_hash_blocksize {
        my($tfm) = @_;
	    eval q({  &ncrypto_tfm_alg_blocksize( &crypto_hash_tfm($tfm)); });
    }' unless defined(&crypto_hash_blocksize);
    eval 'sub crypto_hash_alignmask {
        my($tfm) = @_;
	    eval q({  &ncrypto_tfm_alg_alignmask( &crypto_hash_tfm($tfm)); });
    }' unless defined(&crypto_hash_alignmask);
    eval 'sub crypto_hash_digestsize {
        my($tfm) = @_;
	    eval q({  &crypto_hash_crt($tfm)-> &digestsize; });
    }' unless defined(&crypto_hash_digestsize);
    eval 'sub crypto_hash_get_flags {
        my($tfm) = @_;
	    eval q({  &ncrypto_tfm_get_flags( &crypto_hash_tfm($tfm)); });
    }' unless defined(&crypto_hash_get_flags);
    eval 'sub crypto_hash_set_flags {
        my($tfm,$flags) = @_;
	    eval q({  &ncrypto_tfm_set_flags( &crypto_hash_tfm($tfm), $flags); });
    }' unless defined(&crypto_hash_set_flags);
    eval 'sub crypto_hash_clear_flags {
        my($tfm,$flags) = @_;
	    eval q({  &ncrypto_tfm_clear_flags( &crypto_hash_tfm($tfm), $flags); });
    }' unless defined(&crypto_hash_clear_flags);
    eval 'sub crypto_hash_init {
        my($desc) = @_;
	    eval q({  &crypto_hash_crt( ($desc->{tfm}))-> &init($desc); });
    }' unless defined(&crypto_hash_init);
    eval 'sub crypto_hash_update {
        my($desc,$sg,$nbytes) = @_;
	    eval q({  &crypto_hash_crt( ($desc->{tfm}))-> &update($desc, $sg, $nbytes); });
    }' unless defined(&crypto_hash_update);
    eval 'sub crypto_hash_final {
        my($desc,$out) = @_;
	    eval q({  &crypto_hash_crt( ($desc->{tfm}))-> &final($desc, $out); });
    }' unless defined(&crypto_hash_final);
    eval 'sub crypto_hash_digest {
        my($desc,$sg,$nbytes,$out) = @_;
	    eval q({  &crypto_hash_crt( ($desc->{tfm}))-> &digest($desc, $sg, $nbytes, $out); });
    }' unless defined(&crypto_hash_digest);
    eval 'sub crypto_hash_setkey {
        my($hash,$key,$keylen) = @_;
	    eval q({  &crypto_hash_crt($hash)-> &setkey($hash, $key, $keylen); });
    }' unless defined(&crypto_hash_setkey);
}
1;
