require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_NFCALLS_H)) {
    eval 'sub _LINUX_NFCALLS_H () {1;}' unless defined(&_LINUX_NFCALLS_H);
    require 'linux/rcupdate.ph';
    if(defined(&CONFIG_MODULES)) {
	eval 'sub DECL_KSYM_MODULE {
	    my($name) = @_;
    	    eval q( &extern \'struct module\' * &vz_mod_$name);
	}' unless defined(&DECL_KSYM_MODULE);
	eval 'sub INIT_KSYM_MODULE {
	    my($name) = @_;
    	    eval q(\'struct module\' * &vz_mod_$name =  &no_module;  &EXPORT_SYMBOL( &vz_mod_$name));
	}' unless defined(&INIT_KSYM_MODULE);
	eval 'sub __vzksym_modresolve {
	    my($modp,$mod) = @_;
    	    eval q({  &wmb();  &synchronize_sched(); *$modp = $mod;  &wmb();  &synchronize_sched(); });
	}' unless defined(&__vzksym_modresolve);
	eval 'sub __vzksym_modunresolve {
	    my($modp) = @_;
    	    eval q({ *$modp =  &no_module;  &synchronize_sched(); });
	}' unless defined(&__vzksym_modunresolve);
	eval 'sub __vzksym_module_get {
	    my($mod) = @_;
    	    eval q({  &smp_read_barrier_depends();  &if (! &try_module_get($mod)) - &EBUSY; 0; });
	}' unless defined(&__vzksym_module_get);
	eval 'sub __vzksym_module_put {
	    my($mod) = @_;
    	    eval q({  &module_put($mod); });
	}' unless defined(&__vzksym_module_put);
    } else {
	eval 'sub DECL_KSYM_MODULE {
	    my($name) = @_;
    	    eval q();
	}' unless defined(&DECL_KSYM_MODULE);
	eval 'sub INIT_KSYM_MODULE {
	    my($name) = @_;
    	    eval q();
	}' unless defined(&INIT_KSYM_MODULE);
	eval 'sub __vzksym_modresolve {
	    my($modp, $mod) = @_;
    	    eval q();
	}' unless defined(&__vzksym_modresolve);
	eval 'sub __vzksym_modunresolve {
	    my($modp) = @_;
    	    eval q();
	}' unless defined(&__vzksym_modunresolve);
	eval 'sub __vzksym_module_get {
	    my($mod) = @_;
    	    eval q((0));
	}' unless defined(&__vzksym_module_get);
	eval 'sub __vzksym_module_put {
	    my($mod) = @_;
    	    eval q();
	}' unless defined(&__vzksym_module_put);
    }
    eval 'sub __KSYMERRCALL {
        my($err, $type, $mod, $name, $args) = @_;
	    eval q(({ $type  &ret = ($type)$err;  &if (! &__vzksym_module_get( &vz_mod_$mod)) {  &if ( &vz_$name)  &ret = ((* &vz_$name)$args);  &__vzksym_module_put( &vz_mod_$mod); }  &ret; }));
    }' unless defined(&__KSYMERRCALL);
    eval 'sub __KSYMSAFECALL_VOID {
        my($mod, $name, $args) = @_;
	    eval q( &do {  &if (! &__vzksym_module_get( &vz_mod_$mod)) {  &if ( &vz_$name) ((* &vz_$name)$args);  &__vzksym_module_put( &vz_mod_$mod); } }  &while (0));
    }' unless defined(&__KSYMSAFECALL_VOID);
    eval 'sub DECL_KSYM_CALL {
        my($type, $name, $args) = @_;
	    eval q( &extern $type (* &vz_$name) $args);
    }' unless defined(&DECL_KSYM_CALL);
    eval 'sub INIT_KSYM_CALL {
        my($type, $name, $args) = @_;
	    eval q($type (* &vz_$name) $args;  &EXPORT_SYMBOL( &vz_$name));
    }' unless defined(&INIT_KSYM_CALL);
    eval 'sub KSYMERRCALL {
        my($err, $mod, $name, $args) = @_;
	    eval q( &__KSYMERRCALL($err, \'int\', $mod, $name, $args));
    }' unless defined(&KSYMERRCALL);
    eval 'sub KSYMSAFECALL {
        my($type, $mod, $name, $args) = @_;
	    eval q( &__KSYMERRCALL(0, $type, $mod, $name, $args));
    }' unless defined(&KSYMSAFECALL);
    eval 'sub KSYMSAFECALL_VOID {
        my($mod, $name, $args) = @_;
	    eval q( &__KSYMSAFECALL_VOID($mod, $name, $args));
    }' unless defined(&KSYMSAFECALL_VOID);
    eval 'sub KSYMREF {
        my($name) = @_;
	    eval q( &vz_$name);
    }' unless defined(&KSYMREF);
    eval 'sub KSYMMODRESOLVE {
        my($name) = @_;
	    eval q( &__vzksym_modresolve( &vz_mod_$name,  &THIS_MODULE));
    }' unless defined(&KSYMMODRESOLVE);
    eval 'sub KSYMMODUNRESOLVE {
        my($name) = @_;
	    eval q( &__vzksym_modunresolve( &vz_mod_$name));
    }' unless defined(&KSYMMODUNRESOLVE);
    eval 'sub KSYMRESOLVE {
        my($name) = @_;
	    eval q( &vz_$name = $name);
    }' unless defined(&KSYMRESOLVE);
    eval 'sub KSYMUNRESOLVE {
        my($name) = @_;
	    eval q( &vz_$name =  &NULL);
    }' unless defined(&KSYMUNRESOLVE);
    if(defined( &CONFIG_VE)) {
	require 'linux/netfilter/x_tables.ph';
    }
    if(defined( &CONFIG_VE_CALLS) || defined( &CONFIG_VE_CALLS_MODULE)) {
    }
}
1;
