require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_PERCPU_H)) {
    eval 'sub __LINUX_PERCPU_H () {1;}' unless defined(&__LINUX_PERCPU_H);
    require 'linux/spinlock.ph';
    require 'linux/slab.ph';
    require 'linux/smp.ph';
    require 'linux/string.ph';
    require 'asm/percpu.ph';
    unless(defined(&PERCPU_ENOUGH_ROOM)) {
	if(defined(&CONFIG_MODULES)) {
	    eval 'sub PERCPU_MODULE_RESERVE () {8192;}' unless defined(&PERCPU_MODULE_RESERVE);
	} else {
	    eval 'sub PERCPU_MODULE_RESERVE () {0;}' unless defined(&PERCPU_MODULE_RESERVE);
	}
	eval 'sub PERCPU_ENOUGH_ROOM () {( &__per_cpu_end -  &__per_cpu_start +  &PERCPU_MODULE_RESERVE);}' unless defined(&PERCPU_ENOUGH_ROOM);
    }
    eval 'sub get_cpu_var {
        my($var) = @_;
	    eval q((*({  &preempt_disable(); & &__get_cpu_var($var); })));
    }' unless defined(&get_cpu_var);
    eval 'sub put_cpu_var {
        my($var) = @_;
	    eval q( &preempt_enable());
    }' unless defined(&put_cpu_var);
    if(defined(&CONFIG_SMP)) {
	eval 'sub per_cpu_ptr {
	    my($ptr, $cpu) = @_;
    	    eval q(({ \'struct percpu_data\' * &__p = ~($ptr); ( &__typeof__($ptr)) ($__p->{ptrs[&(cpu)]}); }));
	}' unless defined(&per_cpu_ptr);
	eval 'sub static_percpu_ptr {
	    my($sptr, $sptrs) = @_;
    	    eval q(({ \'int\'  &i;  &for ( &i = 0;  &i <  &NR_CPUS;  &i++) ($sptr)-> $ptrs[ &i] = ($sptrs)[ &i]; (( &void *)(~($sptr))); }));
	}' unless defined(&static_percpu_ptr);
    } else {
	eval 'sub per_cpu_ptr {
	    my($ptr, $cpu) = @_;
    	    eval q(({ ( &void)($cpu); ($ptr); }));
	}' unless defined(&per_cpu_ptr);
	eval 'sub static_percpu_ptr {
	    my($sptr, $sptrs) = @_;
    	    eval q(($sptrs->[0]));
	}' unless defined(&static_percpu_ptr);
	eval 'sub void {
	    eval q(* &__alloc_percpu_mask(\'size_t\'  &size,  &gfp_t  &gfp) {  &void * &ret =  &kmalloc( &size,  &gfp);  &if ( &ret)  &memset( &ret, 0,  &size);  &ret; });
	}' unless defined(&void);
	eval 'sub free_percpu {
	    my($ptr) = @_;
    	    eval q({  &kfree($ptr); });
	}' unless defined(&free_percpu);
    }
    eval 'sub alloc_percpu {
        my($type) = @_;
	    eval q((($type *)( &__alloc_percpu_mask($sizeof{$type},  &GFP_KERNEL))));
    }' unless defined(&alloc_percpu);
    eval 'sub alloc_percpu_atomic {
        my($type) = @_;
	    eval q((($type *)( &__alloc_percpu_mask($sizeof{$type},  &GFP_ATOMIC))));
    }' unless defined(&alloc_percpu_atomic);
}
1;
