require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_PID_H)) {
    eval 'sub _LINUX_PID_H () {1;}' unless defined(&_LINUX_PID_H);
    require 'linux/rcupdate.ph';
    eval 'sub VPID_BIT () {10;}' unless defined(&VPID_BIT);
    eval 'sub VPID_DIV () {(1<< &VPID_BIT);}' unless defined(&VPID_DIV);
    if(defined(&CONFIG_VE)) {
	eval 'sub __is_virtual_pid {
	    my($pid) = @_;
    	    eval q((($pid) &  &VPID_DIV));
	}' unless defined(&__is_virtual_pid);
	eval 'sub is_virtual_pid {
	    my($pid) = @_;
    	    eval q(( &__is_virtual_pid($pid) || (($pid)==1 && ! &ve_is_super( &get_exec_env()))));
	}' unless defined(&is_virtual_pid);
    } else {
	eval 'sub __is_virtual_pid {
	    my($pid) = @_;
    	    eval q(0);
	}' unless defined(&__is_virtual_pid);
	eval 'sub is_virtual_pid {
	    my($pid) = @_;
    	    eval q(0);
	}' unless defined(&is_virtual_pid);
    }
    eval("sub PIDTYPE_PID () { 0; }") unless defined(&PIDTYPE_PID);
    eval("sub PIDTYPE_PGID () { 1; }") unless defined(&PIDTYPE_PGID);
    eval("sub PIDTYPE_SID () { 2; }") unless defined(&PIDTYPE_SID);
    eval("sub PIDTYPE_MAX () { 3; }") unless defined(&PIDTYPE_MAX);
    if(defined(&CONFIG_VE)) {
    }
    if(defined(&CONFIG_USER_RESOURCE)) {
    }
    eval 'sub PIDMAP_ENTRIES () {(( &PID_MAX_LIMIT + 8* &PAGE_SIZE - 1)/ &PAGE_SIZE/8);}' unless defined(&PIDMAP_ENTRIES);
    eval 'sub BITS_PER_PAGE () {( &PAGE_SIZE*8);}' unless defined(&BITS_PER_PAGE);
    if(defined(&CONFIG_VE)) {
	eval 'sub PIDMAP_NRFREE () {( &BITS_PER_PAGE/2);}' unless defined(&PIDMAP_NRFREE);
    } else {
	eval 'sub PIDMAP_NRFREE () { &BITS_PER_PAGE;}' unless defined(&PIDMAP_NRFREE);
    }
    eval 'sub pid {
        eval q(* &get_pid(\'struct pid\' * &pid) {  &if ( &pid)  &atomic_inc( ($pid->{count}));  &pid; });
    }' unless defined(&pid);
    unless(defined(&CONFIG_VE)) {
	eval 'sub vpid_to_pid {
	    my($pid) = @_;
    	    eval q(($pid));
	}' unless defined(&vpid_to_pid);
	eval 'sub __vpid_to_pid {
	    my($pid) = @_;
    	    eval q(($pid));
	}' unless defined(&__vpid_to_pid);
	eval 'sub vpid_to_pid_ve {
	    my($pid, $ve) = @_;
    	    eval q(($pid));
	}' unless defined(&vpid_to_pid_ve);
	eval 'sub pid_to_vpid {
	    my($pid) = @_;
    	    eval q(($pid));
	}' unless defined(&pid_to_vpid);
	eval 'sub _pid_to_vpid {
	    my($pid) = @_;
    	    eval q(($pid));
	}' unless defined(&_pid_to_vpid);
	eval 'sub comb_vpid_to_pid {
	    my($pid) = @_;
    	    eval q(($pid));
	}' unless defined(&comb_vpid_to_pid);
	eval 'sub comb_pid_to_vpid {
	    my($pid) = @_;
    	    eval q(($pid));
	}' unless defined(&comb_pid_to_vpid);
    } else {
	eval 'sub comb_vpid_to_pid {
	    my($vpid) = @_;
    	    eval q({ \'int\'  &pid = $vpid;  &if ($vpid > 0) {  &pid =  &vpid_to_pid($vpid);  &if ( &unlikely( &pid < 0)) 0; }  &else  &if ($vpid < 0) {  &pid =  &vpid_to_pid(-$vpid);  &if ( &unlikely( &pid < 0)) 0;  &pid = - &pid; }  &pid; });
	}' unless defined(&comb_vpid_to_pid);
	eval 'sub comb_pid_to_vpid {
	    my($pid) = @_;
    	    eval q({ \'int\'  &vpid = $pid;  &if ($pid > 0) {  &vpid =  &pid_to_vpid($pid);  &if ( &unlikely( &vpid < 0)) 0; }  &else  &if ($pid < 0) {  &vpid =  &pid_to_vpid(-$pid);  &if ( &unlikely( &vpid < 0)) 0;  &vpid = - &vpid; }  &vpid; });
	}' unless defined(&comb_pid_to_vpid);
    }
    eval 'sub pid_next_all {
        my($task, $type) = @_;
	    eval q((($task)-> ($pids[&(type)]->{node}->{next})));
    }' unless defined(&pid_next_all);
    eval 'sub pid_next_task_all {
        my($task, $type) = @_;
	    eval q( &hlist_entry( &pid_next_all($task, $type), \'struct task_struct\',  ($pids[&(type)]->{node})));
    }' unless defined(&pid_next_task_all);
    eval 'sub do_each_task_pid_all {
        my($who, $type, $task) = @_;
	    eval q( &if (($task =  &find_task_by_pid_type_all($type, $who))) {  &prefetch( &pid_next_all($task, $type));  &do {);
    }' unless defined(&do_each_task_pid_all);
    eval 'sub while_each_task_pid_all {
        my($who, $type, $task) = @_;
	    eval q(}  &while ( &pid_next_all($task, $type)  && ({ $task =  &pid_next_task_all($task, $type);  &rcu_dereference($task);  &prefetch( &pid_next_all($task, $type)); 1; }) ); });
    }' unless defined(&while_each_task_pid_all);
    unless(defined(&CONFIG_VE)) {
	eval 'sub __do_each_task_pid_ve {
	    my($who, $type, $task, $owner) = @_;
    	    eval q( &do_each_task_pid_all($who, $type, $task));
	}' unless defined(&__do_each_task_pid_ve);
	eval 'sub __while_each_task_pid_ve {
	    my($who, $type, $task, $owner) = @_;
    	    eval q( &while_each_task_pid_all($who, $type, $task));
	}' unless defined(&__while_each_task_pid_ve);
    } else {
	eval 'sub __do_each_task_pid_ve {
	    my($who, $type, $task, $owner) = @_;
    	    eval q( &do_each_task_pid_all($who, $type, $task)  &if ( &ve_accessible( &VE_TASK_INFO($task)-> &owner_env, $owner)));
	}' unless defined(&__do_each_task_pid_ve);
	eval 'sub __while_each_task_pid_ve {
	    my($who, $type, $task, $owner) = @_;
    	    eval q( &while_each_task_pid_all($who, $type, $task));
	}' unless defined(&__while_each_task_pid_ve);
    }
    eval 'sub do_each_task_pid_ve {
        my($who, $type, $task) = @_;
	    eval q( &__do_each_task_pid_ve($who, $type, $task,  &get_exec_env()););
    }' unless defined(&do_each_task_pid_ve);
    eval 'sub while_each_task_pid_ve {
        my($who, $type, $task) = @_;
	    eval q( &__while_each_task_pid_ve($who, $type, $task,  &get_exec_env()););
    }' unless defined(&while_each_task_pid_ve);
}
1;
