require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_PROC_FS_H)) {
    eval 'sub _LINUX_PROC_FS_H () {1;}' unless defined(&_LINUX_PROC_FS_H);
    require 'linux/slab.ph';
    require 'linux/fs.ph';
    require 'linux/spinlock.ph';
    require 'linux/smp_lock.ph';
    require 'asm/atomic.ph';
    eval 'sub FIRST_PROCESS_ENTRY () {256;}' unless defined(&FIRST_PROCESS_ENTRY);
    eval("sub PROC_ROOT_INO () { 1; }") unless defined(&PROC_ROOT_INO);
    eval 'sub PROC_SUPER_MAGIC () {0x9fa0;}' unless defined(&PROC_SUPER_MAGIC);
    if(defined(&CONFIG_PROC_FS)) {
	if(defined(&CONFIG_VE)) {
	    require 'linux/sched.ph';
	    eval 'sub proc_net () {( &get_exec_env()-> &_proc_net);}' unless defined(&proc_net);
	    eval 'sub proc_net_stat () {( &get_exec_env()-> &_proc_net_stat);}' unless defined(&proc_net_stat);
	} else {
	}
	if(defined(&CONFIG_PROC_DEVICETREE)) {
	}
	eval 'sub proc_dir_entry {
	    eval q(* &create_proc_read_entry( &const \'char\' * &name,  &mode_t  &mode, \'struct proc_dir_entry\' * &base,  &read_proc_t * &read_proc,  &void *  &data) { \'struct proc_dir_entry\' * &res= &create_proc_entry( &name, &mode, &base);  &if ( &res) {  ($res->{read_proc})= &read_proc;  ($res->{data})= &data; }  &res; });
	}' unless defined(&proc_dir_entry);
	eval 'sub proc_dir_entry {
	    eval q(* &proc_net_fops_create( &const \'char\' * &name,  &mode_t  &mode,  &const \'struct file_operations\' * &fops) { \'struct proc_dir_entry\' * &res =  &create_proc_entry( &name,  &mode,  &proc_net);  &if ( &res)  ($res->{proc_fops}) =  &fops;  &res; });
	}' unless defined(&proc_dir_entry);
	eval 'sub proc_dir_entry {
	    eval q(* &proc_glob_fops_create( &const \'char\' * &name,  &mode_t  &mode, \'struct file_operations\' * &fops) { \'struct proc_dir_entry\' * &res =  &create_proc_glob_entry( &name,  &mode,  &NULL);  &if ( &res)  ($res->{proc_fops}) =  &fops;  &res; });
	}' unless defined(&proc_dir_entry);
	eval 'sub proc_net_remove {
	    my($name) = @_;
    	    eval q({  &remove_proc_entry($name, &proc_net); });
	}' unless defined(&proc_net_remove);
    } else {
	eval 'sub proc_root_driver () { &NULL;}' unless defined(&proc_root_driver);
	eval 'sub proc_net () { &NULL;}' unless defined(&proc_net);
	eval 'sub proc_bus () { &NULL;}' unless defined(&proc_bus);
	eval 'sub proc_net_fops_create {
	    my($name, $mode, $fops) = @_;
    	    eval q(({ ( &void)($mode),  &NULL; }));
	}' unless defined(&proc_net_fops_create);
	eval 'sub proc_glob_fops_create {
	    my($name, $mode, $fops) = @_;
    	    eval q(({ ( &void)($mode),  &NULL; }));
	}' unless defined(&proc_glob_fops_create);
	eval 'sub proc_net_create {
	    my($name, $mode, $info) = @_;
    	    eval q(({ ( &void)($mode),  &NULL; }));
	}' unless defined(&proc_net_create);
	eval 'sub proc_dir_entry {
	    eval q(* &proc_create( &const \'char\' * &name,  &mode_t  &mode, \'struct proc_dir_entry\' * &parent,  &const \'struct file_operations\' * &proc_fops) {  &NULL; });
	}' unless defined(&proc_dir_entry);
	eval 'sub remove_proc_entry {
	    my($name, $parent) = @_;
    	    eval q( &do {}  &while (0));
	}' unless defined(&remove_proc_entry);
    }
    eval 'sub proc_dir_entry {
        eval q(* &create_proc_entry_mod( &const \'char\' * &name,  &mode_t  &mode, \'struct proc_dir_entry\' * &parent, \'struct module\' * &owner) { \'struct proc_dir_entry\' * &ent;  &lock_kernel();  &ent =  &create_proc_entry( &name,  &mode,  &parent);  &if ( &ent)  ($ent->{owner}) =  &owner;  &unlock_kernel();  &ent; });
    }' unless defined(&proc_dir_entry);
    eval 'sub proc_dir_entry {
        eval q(* &create_proc_glob_entry_mod( &const \'char\' * &name,  &mode_t  &mode, \'struct proc_dir_entry\' * &parent, \'struct module\' * &owner) { \'struct proc_dir_entry\' * &ent;  &lock_kernel();  &ent =  &create_proc_glob_entry( &name,  &mode,  &parent);  &if ( &ent)  ($ent->{owner}) =  &owner;  &unlock_kernel();  &ent; });
    }' unless defined(&proc_dir_entry);
    if(!defined( &CONFIG_PROC_KCORE)) {
	eval 'sub kclist_add {
	    my($new,$addr,$size) = @_;
    	    eval q({ });
	}' unless defined(&kclist_add);
    } else {
    }
    eval 'sub proc_inode {
        eval q(* &PROC_I( &const \'struct inode\' * &inode) {  &container_of( &inode, \'struct proc_inode\',  &vfs_inode); });
    }' unless defined(&proc_inode);
    eval 'sub proc_dir_entry {
        eval q(* &PDE( &const \'struct inode\' * &inode) {  &PROC_I( &inode)-> &pde; });
    }' unless defined(&proc_dir_entry);
    eval 'sub de_get {
        my($de) = @_;
	    eval q({  &if ($de)  &atomic_inc( ($de->{count})); $de; });
    }' unless defined(&de_get);
    eval 'sub LPDE {
        my($inode) = @_;
	    eval q(( &PROC_I(($inode))-> &pde));
    }' unless defined(&LPDE);
    if(defined(&CONFIG_VE)) {
	eval 'sub GPDE {
	    my($inode) = @_;
    	    eval q((*(($inode)-> &i_pipe)));
	}' unless defined(&GPDE);
    }
}
1;
