require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__RFKILL_H)) {
    eval 'sub __RFKILL_H () {1;}' unless defined(&__RFKILL_H);
    require 'linux/types.ph';
    eval 'sub RFKILL_STATE_SOFT_BLOCKED () {0;}' unless defined(&RFKILL_STATE_SOFT_BLOCKED);
    eval 'sub RFKILL_STATE_UNBLOCKED () {1;}' unless defined(&RFKILL_STATE_UNBLOCKED);
    eval 'sub RFKILL_STATE_HARD_BLOCKED () {2;}' unless defined(&RFKILL_STATE_HARD_BLOCKED);
    eval("sub RFKILL_TYPE_ALL () { 0; }") unless defined(&RFKILL_TYPE_ALL);
    eval("sub RFKILL_TYPE_WLAN () { 1; }") unless defined(&RFKILL_TYPE_WLAN);
    eval("sub RFKILL_TYPE_BLUETOOTH () { 2; }") unless defined(&RFKILL_TYPE_BLUETOOTH);
    eval("sub RFKILL_TYPE_UWB () { 3; }") unless defined(&RFKILL_TYPE_UWB);
    eval("sub RFKILL_TYPE_WIMAX () { 4; }") unless defined(&RFKILL_TYPE_WIMAX);
    eval("sub RFKILL_TYPE_WWAN () { 5; }") unless defined(&RFKILL_TYPE_WWAN);
    eval("sub RFKILL_TYPE_GPS () { 6; }") unless defined(&RFKILL_TYPE_GPS);
    eval("sub NUM_RFKILL_TYPES () { 7; }") unless defined(&NUM_RFKILL_TYPES);
    eval("sub RFKILL_OP_ADD () { 0; }") unless defined(&RFKILL_OP_ADD);
    eval("sub RFKILL_OP_DEL () { 1; }") unless defined(&RFKILL_OP_DEL);
    eval("sub RFKILL_OP_CHANGE () { 2; }") unless defined(&RFKILL_OP_CHANGE);
    eval("sub RFKILL_OP_CHANGE_ALL () { 3; }") unless defined(&RFKILL_OP_CHANGE_ALL);
    eval 'sub RFKILL_EVENT_SIZE_V1 () {8;}' unless defined(&RFKILL_EVENT_SIZE_V1);
    eval 'sub RFKILL_IOC_MAGIC () {ord(\'R\');}' unless defined(&RFKILL_IOC_MAGIC);
    eval 'sub RFKILL_IOC_NOINPUT () {1;}' unless defined(&RFKILL_IOC_NOINPUT);
    eval 'sub RFKILL_IOCTL_NOINPUT () { &_IO( &RFKILL_IOC_MAGIC,  &RFKILL_IOC_NOINPUT);}' unless defined(&RFKILL_IOCTL_NOINPUT);
    if(defined(&__KERNEL__)) {
	eval("sub RFKILL_USER_STATE_SOFT_BLOCKED () { RFKILL_STATE_SOFT_BLOCKED; }") unless defined(&RFKILL_USER_STATE_SOFT_BLOCKED);
	eval("sub RFKILL_USER_STATE_UNBLOCKED () { RFKILL_STATE_UNBLOCKED; }") unless defined(&RFKILL_USER_STATE_UNBLOCKED);
	eval("sub RFKILL_USER_STATE_HARD_BLOCKED () { RFKILL_STATE_HARD_BLOCKED; }") unless defined(&RFKILL_USER_STATE_HARD_BLOCKED);
	undef(&RFKILL_STATE_SOFT_BLOCKED) if defined(&RFKILL_STATE_SOFT_BLOCKED);
	undef(&RFKILL_STATE_UNBLOCKED) if defined(&RFKILL_STATE_UNBLOCKED);
	undef(&RFKILL_STATE_HARD_BLOCKED) if defined(&RFKILL_STATE_HARD_BLOCKED);
	require 'linux/kernel.ph';
	require 'linux/list.ph';
	require 'linux/mutex.ph';
	require 'linux/device.ph';
	require 'linux/leds.ph';
	require 'linux/err.ph';
	if(defined( &CONFIG_RFKILL) || defined( &CONFIG_RFKILL_MODULE)) {
	} else {
	    eval 'sub rfkill_alloc {
	        my($name,$parent,$type,$ops,$ops_data) = @_;
    		eval q({  &ERR_PTR(- &ENODEV); });
	    }' unless defined(&rfkill_alloc);
	    eval 'sub rfkill_register {
	        my($rfkill) = @_;
    		eval q({  &if ($rfkill ==  &ERR_PTR(- &ENODEV)) 0; - &EINVAL; });
	    }' unless defined(&rfkill_register);
	    eval 'sub rfkill_pause_polling {
	        my($rfkill) = @_;
    		eval q({ });
	    }' unless defined(&rfkill_pause_polling);
	    eval 'sub rfkill_resume_polling {
	        my($rfkill) = @_;
    		eval q({ });
	    }' unless defined(&rfkill_resume_polling);
	    eval 'sub rfkill_unregister {
	        my($rfkill) = @_;
    		eval q({ });
	    }' unless defined(&rfkill_unregister);
	    eval 'sub rfkill_destroy {
	        my($rfkill) = @_;
    		eval q({ });
	    }' unless defined(&rfkill_destroy);
	    eval 'sub rfkill_set_hw_state {
	        my($rfkill,$blocked) = @_;
    		eval q({ $blocked; });
	    }' unless defined(&rfkill_set_hw_state);
	    eval 'sub rfkill_set_sw_state {
	        my($rfkill,$blocked) = @_;
    		eval q({ $blocked; });
	    }' unless defined(&rfkill_set_sw_state);
	    eval 'sub rfkill_init_sw_state {
	        my($rfkill,$blocked) = @_;
    		eval q({ });
	    }' unless defined(&rfkill_init_sw_state);
	    eval 'sub rfkill_set_states {
	        my($rfkill,$sw,$hw) = @_;
    		eval q({ });
	    }' unless defined(&rfkill_set_states);
	    eval 'sub rfkill_blocked {
	        my($rfkill) = @_;
    		eval q({  &false; });
	    }' unless defined(&rfkill_blocked);
	}
	if(defined(&CONFIG_RFKILL_LEDS)) {
	} else {
	    eval 'sub char {
	        eval q(* &rfkill_get_led_trigger_name(\'struct rfkill\' * &rfkill) {  &NULL; });
	    }' unless defined(&char);
	    eval 'sub rfkill_set_led_trigger_name {
	        my($rfkill,$name) = @_;
    		eval q({ });
	    }' unless defined(&rfkill_set_led_trigger_name);
	}
    }
}
1;
