require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_SCHED_H)) {
    eval 'sub _LINUX_SCHED_H () {1;}' unless defined(&_LINUX_SCHED_H);
    require 'linux/auxvec.ph';
    eval 'sub CSIGNAL () {0xff;}' unless defined(&CSIGNAL);
    eval 'sub CLONE_VM () {0x100;}' unless defined(&CLONE_VM);
    eval 'sub CLONE_FS () {0x200;}' unless defined(&CLONE_FS);
    eval 'sub CLONE_FILES () {0x400;}' unless defined(&CLONE_FILES);
    eval 'sub CLONE_SIGHAND () {0x800;}' unless defined(&CLONE_SIGHAND);
    eval 'sub CLONE_PTRACE () {0x2000;}' unless defined(&CLONE_PTRACE);
    eval 'sub CLONE_VFORK () {0x4000;}' unless defined(&CLONE_VFORK);
    eval 'sub CLONE_PARENT () {0x8000;}' unless defined(&CLONE_PARENT);
    eval 'sub CLONE_THREAD () {0x10000;}' unless defined(&CLONE_THREAD);
    eval 'sub CLONE_NEWNS () {0x20000;}' unless defined(&CLONE_NEWNS);
    eval 'sub CLONE_SYSVSEM () {0x40000;}' unless defined(&CLONE_SYSVSEM);
    eval 'sub CLONE_SETTLS () {0x80000;}' unless defined(&CLONE_SETTLS);
    eval 'sub CLONE_PARENT_SETTID () {0x100000;}' unless defined(&CLONE_PARENT_SETTID);
    eval 'sub CLONE_CHILD_CLEARTID () {0x200000;}' unless defined(&CLONE_CHILD_CLEARTID);
    eval 'sub CLONE_DETACHED () {0x400000;}' unless defined(&CLONE_DETACHED);
    eval 'sub CLONE_UNTRACED () {0x800000;}' unless defined(&CLONE_UNTRACED);
    eval 'sub CLONE_CHILD_SETTID () {0x1000000;}' unless defined(&CLONE_CHILD_SETTID);
    eval 'sub CLONE_STOPPED () {0x2000000;}' unless defined(&CLONE_STOPPED);
    eval 'sub CLONE_NEWUTS () {0x4000000;}' unless defined(&CLONE_NEWUTS);
    eval 'sub CLONE_NEWIPC () {0x8000000;}' unless defined(&CLONE_NEWIPC);
    eval 'sub CLONE_NAMESPACES_MASK () {( &CLONE_NEWUTS |  &CLONE_NEWIPC);}' unless defined(&CLONE_NAMESPACES_MASK);
    eval 'sub SCHED_NORMAL () {0;}' unless defined(&SCHED_NORMAL);
    eval 'sub SCHED_FIFO () {1;}' unless defined(&SCHED_FIFO);
    eval 'sub SCHED_RR () {2;}' unless defined(&SCHED_RR);
    eval 'sub SCHED_BATCH () {3;}' unless defined(&SCHED_BATCH);
    if(defined(&__KERNEL__)) {
	require 'asm/param.ph';
	require 'linux/capability.ph';
	require 'linux/threads.ph';
	require 'linux/kernel.ph';
	require 'linux/types.ph';
	require 'linux/timex.ph';
	require 'linux/jiffies.ph';
	require 'linux/rbtree.ph';
	require 'linux/thread_info.ph';
	require 'linux/cpumask.ph';
	require 'linux/errno.ph';
	require 'linux/nodemask.ph';
	require 'asm/system.ph';
	require 'asm/semaphore.ph';
	require 'asm/page.ph';
	require 'asm/ptrace.ph';
	require 'asm/mmu.ph';
	require 'asm/cputime.ph';
	require 'linux/smp.ph';
	require 'linux/sem.ph';
	require 'linux/signal.ph';
	require 'linux/securebits.ph';
	require 'linux/fs_struct.ph';
	require 'linux/compiler.ph';
	require 'linux/completion.ph';
	require 'linux/cpumask.ph';
	require 'linux/pid.ph';
	require 'linux/percpu.ph';
	require 'linux/topology.ph';
	require 'linux/seccomp.ph';
	require 'linux/rcupdate.ph';
	require 'linux/futex.ph';
	require 'linux/rtmutex.ph';
	require 'linux/time.ph';
	require 'linux/param.ph';
	require 'linux/resource.ph';
	require 'linux/timer.ph';
	require 'linux/hrtimer.ph';
	require 'linux/task_io_accounting.ph';
	require 'asm/processor.ph';
	require 'ub/ub_task.ph';
	eval 'sub CLONE_KERNEL () {( &CLONE_FS |  &CLONE_FILES |  &CLONE_SIGHAND);}' unless defined(&CLONE_KERNEL);
	eval 'sub FSHIFT () {11;}' unless defined(&FSHIFT);
	eval 'sub FIXED_1 () {(1<< &FSHIFT);}' unless defined(&FIXED_1);
	eval 'sub LOAD_FREQ () {(5* &HZ);}' unless defined(&LOAD_FREQ);
	eval 'sub EXP_1 () {1884;}' unless defined(&EXP_1);
	eval 'sub EXP_5 () {2014;}' unless defined(&EXP_5);
	eval 'sub EXP_15 () {2037;}' unless defined(&EXP_15);
	eval 'sub CALC_LOAD {
	    my($load,$exp,$n) = @_;
    	    eval q($load *= $exp; $load += $n*( &FIXED_1-$exp); $load >>=  &FSHIFT;);
	}' unless defined(&CALC_LOAD);
	eval 'sub LOAD_INT {
	    my($x) = @_;
    	    eval q((($x) >>  &FSHIFT));
	}' unless defined(&LOAD_INT);
	eval 'sub LOAD_FRAC {
	    my($x) = @_;
    	    eval q( &LOAD_INT((($x) & ( &FIXED_1-1)) * 100));
	}' unless defined(&LOAD_FRAC);
	if(defined(&CONFIG_VE)) {
	} else {
	    eval 'sub nr_running_vsched {
	        my($vsched) = @_;
    		eval q(0);
	    }' unless defined(&nr_running_vsched);
	    eval 'sub nr_iowait_ve () {
	        eval q(0);
	    }' unless defined(&nr_iowait_ve);
	    eval 'sub nr_unint_vsched {
	        my($vsched) = @_;
    		eval q(0);
	    }' unless defined(&nr_unint_vsched);
	}
	eval 'sub TASK_RUNNING () {0;}' unless defined(&TASK_RUNNING);
	eval 'sub TASK_INTERRUPTIBLE () {1;}' unless defined(&TASK_INTERRUPTIBLE);
	eval 'sub TASK_UNINTERRUPTIBLE () {2;}' unless defined(&TASK_UNINTERRUPTIBLE);
	eval 'sub TASK_STOPPED () {4;}' unless defined(&TASK_STOPPED);
	eval 'sub TASK_TRACED () {8;}' unless defined(&TASK_TRACED);
	eval 'sub EXIT_ZOMBIE () {16;}' unless defined(&EXIT_ZOMBIE);
	eval 'sub EXIT_DEAD () {32;}' unless defined(&EXIT_DEAD);
	eval 'sub TASK_NONINTERACTIVE () {64;}' unless defined(&TASK_NONINTERACTIVE);
	eval 'sub __set_task_state {
	    my($tsk, $state_value) = @_;
    	    eval q( &do { ($tsk)-> &state = ($state_value); }  &while (0));
	}' unless defined(&__set_task_state);
	eval 'sub set_task_state {
	    my($tsk, $state_value) = @_;
    	    eval q( &set_mb(($tsk)-> &state, ($state_value)));
	}' unless defined(&set_task_state);
	eval 'sub __set_current_state {
	    my($state_value) = @_;
    	    eval q( &do {  ($current->{state}) = ($state_value); }  &while (0));
	}' unless defined(&__set_current_state);
	eval 'sub set_current_state {
	    my($state_value) = @_;
    	    eval q( &set_mb( ($current->{state}), ($state_value)));
	}' unless defined(&set_current_state);
	eval 'sub TASK_COMM_LEN () {16;}' unless defined(&TASK_COMM_LEN);
	require 'linux/spinlock.ph';
	if(defined(&CONFIG_DETECT_SOFTLOCKUP)) {
	} else {
	    eval 'sub softlockup_get_next_event {
	        my($void) = @_;
    		eval q({  &MAX_JIFFY_OFFSET; });
	    }' unless defined(&softlockup_get_next_event);
	    eval 'sub softlockup_tick {
	        my($regs) = @_;
    		eval q({ });
	    }' unless defined(&softlockup_tick);
	    eval 'sub spawn_softlockup_task {
	        my($void) = @_;
    		eval q({ });
	    }' unless defined(&spawn_softlockup_task);
	    eval 'sub touch_softlockup_watchdog {
	        my($void) = @_;
    		eval q({ });
	    }' unless defined(&touch_softlockup_watchdog);
	    eval 'sub touch_all_softlockup_watchdogs {
	        my($void) = @_;
    		eval q({ });
	    }' unless defined(&touch_all_softlockup_watchdogs);
	}
	if(defined(&CONFIG_DETECT_HUNG_TASK)) {
	}
	eval 'sub __sched () { &__attribute__(( &__section__(".sched.text")));}' unless defined(&__sched);
	eval 'sub MAX_SCHEDULE_TIMEOUT () { &LONG_MAX;}' unless defined(&MAX_SCHEDULE_TIMEOUT);
	eval 'sub DEFAULT_MAX_MAP_COUNT () {65536;}' unless defined(&DEFAULT_MAX_MAP_COUNT);
	require 'linux/aio.ph';
	if((defined(&NR_CPUS) ? &NR_CPUS : 0) >= (defined(&CONFIG_SPLIT_PTLOCK_CPUS) ? &CONFIG_SPLIT_PTLOCK_CPUS : 0)) {
	    eval 'sub set_mm_counter {
	        my($mm, $member, $value) = @_;
    		eval q( &atomic_long_set(($mm)-> &_$member, $value));
	    }' unless defined(&set_mm_counter);
	    eval 'sub get_mm_counter {
	        my($mm, $member) = @_;
    		eval q(( &atomic_long_read(($mm)-> &_$member)));
	    }' unless defined(&get_mm_counter);
	    eval 'sub add_mm_counter {
	        my($mm, $member, $value) = @_;
    		eval q( &atomic_long_add($value, ($mm)-> &_$member));
	    }' unless defined(&add_mm_counter);
	    eval 'sub inc_mm_counter {
	        my($mm, $member) = @_;
    		eval q( &atomic_long_inc(($mm)-> &_$member));
	    }' unless defined(&inc_mm_counter);
	    eval 'sub dec_mm_counter {
	        my($mm, $member) = @_;
    		eval q( &atomic_long_dec(($mm)-> &_$member));
	    }' unless defined(&dec_mm_counter);
	} else {
	    eval 'sub set_mm_counter {
	        my($mm, $member, $value) = @_;
    		eval q(($mm)-> &_$member = ($value));
	    }' unless defined(&set_mm_counter);
	    eval 'sub get_mm_counter {
	        my($mm, $member) = @_;
    		eval q((($mm)-> &_$member));
	    }' unless defined(&get_mm_counter);
	    eval 'sub add_mm_counter {
	        my($mm, $member, $value) = @_;
    		eval q(($mm)-> &_$member += ($value));
	    }' unless defined(&add_mm_counter);
	    eval 'sub inc_mm_counter {
	        my($mm, $member) = @_;
    		eval q(($mm)-> &_$member++);
	    }' unless defined(&inc_mm_counter);
	    eval 'sub dec_mm_counter {
	        my($mm, $member) = @_;
    		eval q(($mm)-> &_$member--);
	    }' unless defined(&dec_mm_counter);
	}
	eval 'sub get_mm_rss {
	    my($mm) = @_;
    	    eval q(( &get_mm_counter($mm,  &file_rss) +  &get_mm_counter($mm,  &anon_rss)));
	}' unless defined(&get_mm_rss);
	eval 'sub update_hiwater_rss {
	    my($mm) = @_;
    	    eval q( &do { \'unsigned long _rss\' =  &get_mm_rss($mm);  &if (($mm)-> &hiwater_rss <  &_rss) ($mm)-> &hiwater_rss =  &_rss; }  &while (0));
	}' unless defined(&update_hiwater_rss);
	eval 'sub update_hiwater_vm {
	    my($mm) = @_;
    	    eval q( &do {  &if (($mm)-> &hiwater_vm < ($mm)-> &total_vm) ($mm)-> &hiwater_vm = ($mm)-> &total_vm; }  &while (0));
	}' unless defined(&update_hiwater_vm);
	eval 'sub MMF_DUMP_ANON_PRIVATE () {0;}' unless defined(&MMF_DUMP_ANON_PRIVATE);
	eval 'sub MMF_DUMP_ANON_SHARED () {1;}' unless defined(&MMF_DUMP_ANON_SHARED);
	eval 'sub MMF_DUMP_MAPPED_PRIVATE () {2;}' unless defined(&MMF_DUMP_MAPPED_PRIVATE);
	eval 'sub MMF_DUMP_MAPPED_SHARED () {3;}' unless defined(&MMF_DUMP_MAPPED_SHARED);
	eval 'sub MMF_DUMP_ELF_HEADERS () {4;}' unless defined(&MMF_DUMP_ELF_HEADERS);
	eval 'sub MMF_DUMP_HUGETLB_PRIVATE () {5;}' unless defined(&MMF_DUMP_HUGETLB_PRIVATE);
	eval 'sub MMF_DUMP_HUGETLB_SHARED () {6;}' unless defined(&MMF_DUMP_HUGETLB_SHARED);
	eval 'sub MMF_DUMP_FILTER_BITS () {7;}' unless defined(&MMF_DUMP_FILTER_BITS);
	eval 'sub MMF_DUMP_FILTER_MASK () {((1<<  &MMF_DUMP_FILTER_BITS) - 1);}' unless defined(&MMF_DUMP_FILTER_MASK);
	eval 'sub MMF_DUMP_FILTER_DEFAULT () {((1<<  &MMF_DUMP_ANON_PRIVATE) | (1<<  &MMF_DUMP_ANON_SHARED));}' unless defined(&MMF_DUMP_FILTER_DEFAULT);
	if(defined( &CONFIG_MMU_NOTIFIER)  && !defined( &__GENKSYMS__)) {
	}
	if(defined(&CONFIG_USER_RESOURCE)) {
	}
	require 'linux/ve_task.ph';
	if(defined(&CONFIG_VE)) {
	}
	if(defined(&CONFIG_KEYS)) {
	}
	if(defined(&CONFIG_BSD_PROCESS_ACCT)) {
	}
	if(defined(&CONFIG_TASKSTATS)) {
	}
	unless(defined(&__GENKSYMS__)) {
	    if(defined(&CONFIG_AUDIT)) {
	    }
	}
	eval 'sub init_signal_aux {
	    my($aux) = @_;
    	    eval q({  &memset($aux, 0, $sizeof{\'struct signal_struct_aux\'}); });
	}' unless defined(&init_signal_aux);
	eval 'sub signal_struct_aux {
	    eval q(* &signal_aux(\'struct signal_struct\' * &sig) {  &container_of( &sig, \'struct signal_with_aux_struct\',  &sig)-> &aux; });
	}' unless defined(&signal_struct_aux);
	if(defined(&__ARCH_WANT_INTERRUPTS_ON_CTXSW)) {
	    eval 'sub __ARCH_WANT_UNLOCKED_CTXSW () {1;}' unless defined(&__ARCH_WANT_UNLOCKED_CTXSW);
	}
	eval 'sub SIGNAL_STOP_STOPPED () {0x1;}' unless defined(&SIGNAL_STOP_STOPPED);
	eval 'sub SIGNAL_STOP_DEQUEUED () {0x2;}' unless defined(&SIGNAL_STOP_DEQUEUED);
	eval 'sub SIGNAL_STOP_CONTINUED () {0x4;}' unless defined(&SIGNAL_STOP_CONTINUED);
	eval 'sub SIGNAL_GROUP_EXIT () {0x8;}' unless defined(&SIGNAL_GROUP_EXIT);
	eval 'sub MAX_USER_RT_PRIO () {100;}' unless defined(&MAX_USER_RT_PRIO);
	eval 'sub MAX_RT_PRIO () { &MAX_USER_RT_PRIO;}' unless defined(&MAX_RT_PRIO);
	eval 'sub MAX_PRIO () {( &MAX_RT_PRIO + 40);}' unless defined(&MAX_PRIO);
	eval 'sub rt_prio {
	    my($prio) = @_;
    	    eval q( &unlikely(($prio) <  &MAX_RT_PRIO));
	}' unless defined(&rt_prio);
	eval 'sub rt_task {
	    my($p) = @_;
    	    eval q( &rt_prio(($p)-> &prio));
	}' unless defined(&rt_task);
	eval 'sub batch_task {
	    my($p) = @_;
    	    eval q(( &unlikely(($p)-> &policy ==  &SCHED_BATCH)));
	}' unless defined(&batch_task);
	eval 'sub has_rt_policy {
	    my($p) = @_;
    	    eval q( &unlikely(($p)-> &policy !=  &SCHED_NORMAL  && ($p)-> &policy !=  &SCHED_BATCH));
	}' unless defined(&has_rt_policy);
	if(defined(&CONFIG_INOTIFY_USER)) {
	}
	if(defined(&CONFIG_KEYS)) {
	}
	eval 'sub INIT_USER () {( &root_user);}' unless defined(&INIT_USER);
	if(defined( &CONFIG_SCHEDSTATS) || defined( &CONFIG_TASK_DELAY_ACCT)) {
	}
	if(defined(&CONFIG_SCHEDSTATS)) {
	}
	if(defined(&CONFIG_TASK_DELAY_ACCT)) {
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub sched_info_on {
	    my($void) = @_;
    	    eval q({ });
	}' unless defined(&sched_info_on);
	eval("sub SCHED_IDLE () { 0; }") unless defined(&SCHED_IDLE);
	eval("sub NOT_IDLE () { 1; }") unless defined(&NOT_IDLE);
	eval("sub NEWLY_IDLE () { 2; }") unless defined(&NEWLY_IDLE);
	eval("sub MAX_IDLE_TYPES () { 3; }") unless defined(&MAX_IDLE_TYPES);
	eval 'sub SCHED_LOAD_SCALE () {128;}' unless defined(&SCHED_LOAD_SCALE);
	if(defined(&CONFIG_SMP)) {
	    eval 'sub SD_LOAD_BALANCE () {1;}' unless defined(&SD_LOAD_BALANCE);
	    eval 'sub SD_BALANCE_NEWIDLE () {2;}' unless defined(&SD_BALANCE_NEWIDLE);
	    eval 'sub SD_BALANCE_EXEC () {4;}' unless defined(&SD_BALANCE_EXEC);
	    eval 'sub SD_BALANCE_FORK () {8;}' unless defined(&SD_BALANCE_FORK);
	    eval 'sub SD_WAKE_IDLE () {16;}' unless defined(&SD_WAKE_IDLE);
	    eval 'sub SD_WAKE_AFFINE () {32;}' unless defined(&SD_WAKE_AFFINE);
	    eval 'sub SD_WAKE_BALANCE () {64;}' unless defined(&SD_WAKE_BALANCE);
	    eval 'sub SD_SHARE_CPUPOWER () {128;}' unless defined(&SD_SHARE_CPUPOWER);
	    eval 'sub SD_POWERSAVINGS_BALANCE () {256;}' unless defined(&SD_POWERSAVINGS_BALANCE);
	    eval 'sub SD_WAKE_IDLE_FAR () {2048;}' unless defined(&SD_WAKE_IDLE_FAR);
	    eval 'sub BALANCE_FOR_POWER () {(( &sched_mc_power_savings ||  &sched_smt_power_savings) ?  &SD_POWERSAVINGS_BALANCE : 0);}' unless defined(&BALANCE_FOR_POWER);
	    eval("sub SD_LV_NONE () { 0; }") unless defined(&SD_LV_NONE);
	    eval("sub SD_LV_SIBLING () { 1; }") unless defined(&SD_LV_SIBLING);
	    eval("sub SD_LV_MC () { 2; }") unless defined(&SD_LV_MC);
	    eval("sub SD_LV_CPU () { 3; }") unless defined(&SD_LV_CPU);
	    eval("sub SD_LV_NODE () { 4; }") unless defined(&SD_LV_NODE);
	    eval("sub SD_LV_ALLNODES () { 5; }") unless defined(&SD_LV_ALLNODES);
	    eval("sub SD_LV_MAX () { 6; }") unless defined(&SD_LV_MAX);
	    if(defined(&CONFIG_SCHEDSTATS)) {
	    }
	}
	eval 'sub NGROUPS_SMALL () {32;}' unless defined(&NGROUPS_SMALL);
	eval 'sub NGROUPS_PER_BLOCK () {(( &PAGE_SIZE / $sizeof{ &gid_t}));}' unless defined(&NGROUPS_PER_BLOCK);
	eval 'sub get_group_info {
	    my($group_info) = @_;
    	    eval q( &do {  &atomic_inc(($group_info)-> &usage); }  &while (0));
	}' unless defined(&get_group_info);
	eval 'sub put_group_info {
	    my($group_info) = @_;
    	    eval q( &do {  &if ( &atomic_dec_and_test(($group_info)-> &usage))  &groups_free($group_info); }  &while (0));
	}' unless defined(&put_group_info);
	eval 'sub GROUP_AT {
	    my($gi, $i) = @_;
    	    eval q((($gi)-> $blocks[($i)/ &NGROUPS_PER_BLOCK][($i)% &NGROUPS_PER_BLOCK]));
	}' unless defined(&GROUP_AT);
	if(defined(&ARCH_HAS_PREFETCH_SWITCH_STACK)) {
	} else {
	}
	eval("sub SLEEP_NORMAL () { 0; }") unless defined(&SLEEP_NORMAL);
	eval("sub SLEEP_NONINTERACTIVE () { 1; }") unless defined(&SLEEP_NONINTERACTIVE);
	eval("sub SLEEP_INTERACTIVE () { 2; }") unless defined(&SLEEP_INTERACTIVE);
	eval("sub SLEEP_INTERRUPTED () { 3; }") unless defined(&SLEEP_INTERRUPTED);
	if(defined(&CONFIG_DETECT_HUNG_TASK)) {
	}
	eval 'sub task_aux {
	    my($tsk) = @_;
    	    eval q((($tsk)-> &auxilliary));
	}' unless defined(&task_aux);
	if(defined(&CONFIG_SMP)) {
	    if(defined(&__ARCH_WANT_UNLOCKED_CTXSW)) {
	    }
	}
	if(defined(&CONFIG_SCHED_VCPU)) {
	}
	if(defined( &CONFIG_SCHEDSTATS) || defined( &CONFIG_TASK_DELAY_ACCT)) {
	}
	if(defined(&CONFIG_VE)) {
	}
	unless(defined(&__GENKSYMS__)) {
	} else {
	}
	if(defined(&CONFIG_KEYS)) {
	}
	if(defined(&CONFIG_UTRACE)) {
	}
	if(defined(&CONFIG_RT_MUTEXES)) {
	}
	if(defined(&CONFIG_DEBUG_MUTEXES)) {
	}
	if(defined(&CONFIG_TRACE_IRQFLAGS)) {
	}
	if(defined(&CONFIG_LOCKDEP)) {
	    eval 'sub MAX_LOCK_DEPTH () {30;}' unless defined(&MAX_LOCK_DEPTH);
	}
	if(defined( &CONFIG_TASK_XACCT)) {
	}
	if(defined(&CONFIG_NUMA)) {
	}
	if(defined(&CONFIG_CPUSETS)) {
	}
	if(defined(&CONFIG_COMPAT)) {
	}
	if(defined(&CONFIG_PTRACE)) {
	}
	if(defined(&CONFIG_TASK_DELAY_ACCT)) {
	}
	if(defined(&CONFIG_USER_RESOURCE)) {
	}
	if(defined(&CONFIG_VE)) {
	}
	if(defined( &CONFIG_VZ_QUOTA) || defined( &CONFIG_VZ_QUOTA_MODULE)) {
	}
	eval 'sub process_group {
	    my($tsk) = @_;
    	    eval q({  ($tsk->{signal}->{pgrp}); });
	}' unless defined(&process_group);
	eval 'sub get_task_struct {
	    my($tsk) = @_;
    	    eval q( &do {  &atomic_inc(($tsk)-> &usage); }  &while(0));
	}' unless defined(&get_task_struct);
	eval 'sub put_task_struct {
	    my($t) = @_;
    	    eval q({  &if ( &atomic_dec_and_test( ($t->{usage})))  &__put_task_struct($t); });
	}' unless defined(&put_task_struct);
	unless(defined(&CONFIG_VE)) {
	    eval 'sub set_pn_state {
	        my($tsk, $state) = @_;
    		eval q( &do { }  &while(0));
	    }' unless defined(&set_pn_state);
	    eval 'sub clear_pn_state {
	        my($tsk) = @_;
    		eval q( &do { }  &while(0));
	    }' unless defined(&clear_pn_state);
	    eval 'sub set_stop_state {
	        my($tsk) = @_;
    		eval q( &do { }  &while(0));
	    }' unless defined(&set_stop_state);
	    eval 'sub clear_stop_state {
	        my($tsk) = @_;
    		eval q( &do { }  &while(0));
	    }' unless defined(&clear_stop_state);
	} else {
	    eval 'sub PN_STOP_TF () {1;}' unless defined(&PN_STOP_TF);
	    eval 'sub PN_STOP_TF_RT () {2;}' unless defined(&PN_STOP_TF_RT);
	    eval 'sub PN_STOP_ENTRY () {3;}' unless defined(&PN_STOP_ENTRY);
	    eval 'sub PN_STOP_FORK () {4;}' unless defined(&PN_STOP_FORK);
	    eval 'sub PN_STOP_VFORK () {5;}' unless defined(&PN_STOP_VFORK);
	    eval 'sub PN_STOP_SIGNAL () {6;}' unless defined(&PN_STOP_SIGNAL);
	    eval 'sub PN_STOP_EXIT () {7;}' unless defined(&PN_STOP_EXIT);
	    eval 'sub PN_STOP_EXEC () {8;}' unless defined(&PN_STOP_EXEC);
	    eval 'sub PN_STOP_LEAVE () {9;}' unless defined(&PN_STOP_LEAVE);
	    eval 'sub set_pn_state {
	        my($tsk,$state) = @_;
    		eval q({  ($tsk->{pn_state}) = $state; });
	    }' unless defined(&set_pn_state);
	    eval 'sub clear_pn_state {
	        my($tsk) = @_;
    		eval q({  ($tsk->{pn_state}) = 0; });
	    }' unless defined(&clear_pn_state);
	    eval 'sub set_stop_state {
	        my($tsk) = @_;
    		eval q({  ($tsk->{stopped_state}) = 1; });
	    }' unless defined(&set_stop_state);
	    eval 'sub clear_stop_state {
	        my($tsk) = @_;
    		eval q({  ($tsk->{stopped_state}) = 0; });
	    }' unless defined(&clear_stop_state);
	}
	eval 'sub PF_ALIGNWARN () {0x1;}' unless defined(&PF_ALIGNWARN);
	eval 'sub PF_STARTING () {0x2;}' unless defined(&PF_STARTING);
	eval 'sub PF_EXITING () {0x4;}' unless defined(&PF_EXITING);
	eval 'sub PF_DEAD () {0x8;}' unless defined(&PF_DEAD);
	eval 'sub PF_EXITPIDONE () {0x10;}' unless defined(&PF_EXITPIDONE);
	eval 'sub PF_FORKNOEXEC () {0x40;}' unless defined(&PF_FORKNOEXEC);
	eval 'sub PF_SUPERPRIV () {0x100;}' unless defined(&PF_SUPERPRIV);
	eval 'sub PF_DUMPCORE () {0x200;}' unless defined(&PF_DUMPCORE);
	eval 'sub PF_SIGNALED () {0x400;}' unless defined(&PF_SIGNALED);
	eval 'sub PF_MEMALLOC () {0x800;}' unless defined(&PF_MEMALLOC);
	eval 'sub PF_FLUSHER () {0x1000;}' unless defined(&PF_FLUSHER);
	eval 'sub PF_USED_MATH () {0x2000;}' unless defined(&PF_USED_MATH);
	eval 'sub PF_EXIT_RESTART () {0x4000;}' unless defined(&PF_EXIT_RESTART);
	eval 'sub PF_NOFREEZE () {0x8000;}' unless defined(&PF_NOFREEZE);
	eval 'sub PF_FROZEN () {0x10000;}' unless defined(&PF_FROZEN);
	eval 'sub PF_FSTRANS () {0x20000;}' unless defined(&PF_FSTRANS);
	eval 'sub PF_KSWAPD () {0x40000;}' unless defined(&PF_KSWAPD);
	eval 'sub PF_SWAPOFF () {0x80000;}' unless defined(&PF_SWAPOFF);
	eval 'sub PF_LESS_THROTTLE () {0x100000;}' unless defined(&PF_LESS_THROTTLE);
	eval 'sub PF_BORROWED_MM () {0x200000;}' unless defined(&PF_BORROWED_MM);
	eval 'sub PF_RANDOMIZE () {0x400000;}' unless defined(&PF_RANDOMIZE);
	eval 'sub PF_SWAPWRITE () {0x800000;}' unless defined(&PF_SWAPWRITE);
	eval 'sub PF_SPREAD_PAGE () {0x1000000;}' unless defined(&PF_SPREAD_PAGE);
	eval 'sub PF_SPREAD_SLAB () {0x2000000;}' unless defined(&PF_SPREAD_SLAB);
	eval 'sub PF_MEMPOLICY () {0x10000000;}' unless defined(&PF_MEMPOLICY);
	eval 'sub PF_MUTEX_TESTER () {0x20000000;}' unless defined(&PF_MUTEX_TESTER);
	eval 'sub PF_PREEMPT_NOTIFIER () {0x40000000;}' unless defined(&PF_PREEMPT_NOTIFIER);
	eval 'sub PF_THREAD_BOUND () {0x80000000;}' unless defined(&PF_THREAD_BOUND);
	eval 'sub clear_stopped_child_used_math {
	    my($child) = @_;
    	    eval q( &do { ($child)-> &flags &= ~ &PF_USED_MATH; }  &while (0));
	}' unless defined(&clear_stopped_child_used_math);
	eval 'sub set_stopped_child_used_math {
	    my($child) = @_;
    	    eval q( &do { ($child)-> &flags |=  &PF_USED_MATH; }  &while (0));
	}' unless defined(&set_stopped_child_used_math);
	eval 'sub clear_used_math () {
	    eval q( &clear_stopped_child_used_math( &current));
	}' unless defined(&clear_used_math);
	eval 'sub set_used_math () {
	    eval q( &set_stopped_child_used_math( &current));
	}' unless defined(&set_used_math);
	eval 'sub conditional_stopped_child_used_math {
	    my($condition, $child) = @_;
    	    eval q( &do { ($child)-> &flags &= ~ &PF_USED_MATH, ($child)-> &flags |= ($condition) ?  &PF_USED_MATH : 0; }  &while (0));
	}' unless defined(&conditional_stopped_child_used_math);
	eval 'sub conditional_used_math {
	    my($condition) = @_;
    	    eval q( &conditional_stopped_child_used_math($condition,  &current));
	}' unless defined(&conditional_used_math);
	eval 'sub copy_to_stopped_child_used_math {
	    my($child) = @_;
    	    eval q( &do { ($child)-> &flags &= ~ &PF_USED_MATH, ($child)-> &flags |=  ($current->{flags}) &  &PF_USED_MATH; }  &while (0));
	}' unless defined(&copy_to_stopped_child_used_math);
	eval 'sub tsk_used_math {
	    my($p) = @_;
    	    eval q((($p)-> &flags &  &PF_USED_MATH));
	}' unless defined(&tsk_used_math);
	eval 'sub used_math () {
	    eval q( &tsk_used_math( &current));
	}' unless defined(&used_math);
	if(defined(&CONFIG_SMP)) {
	} else {
	    eval 'sub set_cpus_allowed_ptr {
	        my($p,$new_mask) = @_;
    		eval q({  &if (! &cpu_isset(0, *$new_mask)) - &EINVAL; 0; });
	    }' unless defined(&set_cpus_allowed_ptr);
	}
	if(defined(&CONFIG_SMP)) {
	} else {
	    eval 'sub set_cpus_allowed {
	        my($p,$new_mask) = @_;
    		eval q({  &if (! &cpu_isset(0, $new_mask)) - &EINVAL; 0; });
	    }' unless defined(&set_cpus_allowed);
	}
	eval 'sub cycles_to_clocks {
	    my($cycles) = @_;
    	    eval q({ my $cycles_per_clock;  &do_div($cycles,  $cycles_per_clock); $cycles; });
	}' unless defined(&cycles_to_clocks);
	eval 'sub cycles_to_jiffies {
	    my($cycles) = @_;
    	    eval q({ my $cycles_per_jiffy;  &do_div($cycles,  $cycles_per_jiffy); $cycles; });
	}' unless defined(&cycles_to_jiffies);
	if(defined(&CONFIG_SMP)) {
	} else {
	    eval 'sub sched_exec () {
	        eval q({});
	    }' unless defined(&sched_exec);
	}
	if(defined(&CONFIG_HOTPLUG_CPU)) {
	} else {
	}
	if(defined(&CONFIG_RT_MUTEXES)) {
	} else {
	    eval 'sub rt_mutex_getprio {
	        my($p) = @_;
    		eval q({  ($p->{normal_prio}); });
	    }' unless defined(&rt_mutex_getprio);
	    eval 'sub rt_mutex_adjust_pi {
	        my($p) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&rt_mutex_adjust_pi);
	}
	unless(defined(&__HAVE_ARCH_KSTACK_END)) {
	    eval 'sub kstack_end {
	        my($addr) = @_;
    		eval q({ !(($addr+$sizeof{ &void}-1) & ( &THREAD_SIZE-$sizeof{ &void})); });
	    }' unless defined(&kstack_end);
	}
	eval 'sub find_task_by_pid {
	    my($nr) = @_;
    	    eval q( &find_task_by_pid_type( &PIDTYPE_PID, $nr));
	}' unless defined(&find_task_by_pid);
	eval 'sub find_task_by_pid_all {
	    my($nr) = @_;
    	    eval q( &find_task_by_pid_type_all( &PIDTYPE_PID, $nr));
	}' unless defined(&find_task_by_pid_all);
	unless(defined(&CONFIG_VE)) {
	    eval 'sub find_task_by_pid_ve () { &find_task_by_pid_all;}' unless defined(&find_task_by_pid_ve);
	    eval 'sub ve_is_super {
	        my($env) = @_;
    		eval q(1);
	    }' unless defined(&ve_is_super);
	    eval 'sub ve_accessible {
	        my($target, $owner) = @_;
    		eval q(1);
	    }' unless defined(&ve_accessible);
	    eval 'sub ve_accessible_strict {
	        my($target, $owner) = @_;
    		eval q(1);
	    }' unless defined(&ve_accessible_strict);
	    eval 'sub ve_accessible_veid {
	        my($target, $owner) = @_;
    		eval q(1);
	    }' unless defined(&ve_accessible_veid);
	    eval 'sub ve_accessible_strict_veid {
	        my($target, $owner) = @_;
    		eval q(1);
	    }' unless defined(&ve_accessible_strict_veid);
	    eval 'sub VEID {
	        my($envid) = @_;
    		eval q(0);
	    }' unless defined(&VEID);
	    eval 'sub virt_pid {
	        my($tsk) = @_;
    		eval q({  ($tsk->{pid}); });
	    }' unless defined(&virt_pid);
	    eval 'sub virt_tgid {
	        my($tsk) = @_;
    		eval q({  ($tsk->{tgid}); });
	    }' unless defined(&virt_tgid);
	    eval 'sub virt_pgid {
	        my($tsk) = @_;
    		eval q({  ($tsk->{signal}->{pgrp}); });
	    }' unless defined(&virt_pgid);
	    eval 'sub virt_sid {
	        my($tsk) = @_;
    		eval q({  ($tsk->{signal}->{session}); });
	    }' unless defined(&virt_sid);
	    eval 'sub get_task_pid_ve {
	        my($tsk, $ve) = @_;
    		eval q( &get_task_pid($tsk));
	    }' unless defined(&get_task_pid_ve);
	    eval 'sub get_task_pid {
	        my($tsk) = @_;
    		eval q({  ($tsk->{pid}); });
	    }' unless defined(&get_task_pid);
	    eval 'sub get_task_tgid {
	        my($tsk) = @_;
    		eval q({  ($tsk->{tgid}); });
	    }' unless defined(&get_task_tgid);
	    eval 'sub get_task_pgid {
	        my($tsk) = @_;
    		eval q({  ($tsk->{signal}->{pgrp}); });
	    }' unless defined(&get_task_pgid);
	    eval 'sub get_task_sid {
	        my($tsk) = @_;
    		eval q({  ($tsk->{signal}->{session}); });
	    }' unless defined(&get_task_sid);
	    eval 'sub set_virt_pid {
	        my($tsk,$pid) = @_;
    		eval q({ });
	    }' unless defined(&set_virt_pid);
	    eval 'sub set_virt_tgid {
	        my($tsk,$pid) = @_;
    		eval q({ });
	    }' unless defined(&set_virt_tgid);
	    eval 'sub set_virt_pgid {
	        my($tsk,$pid) = @_;
    		eval q({ });
	    }' unless defined(&set_virt_pgid);
	    eval 'sub set_virt_sid {
	        my($tsk,$pid) = @_;
    		eval q({ });
	    }' unless defined(&set_virt_sid);
	    eval 'sub get_task_ppid {
	        my($p) = @_;
    		eval q({  &pid_alive($p) ?  ($p->{group_leader}->{parent}->{tgid}) : 0; });
	    }' unless defined(&get_task_ppid);
	    eval 'sub task_struct {
	        eval q(* &find_task_by_pid_type_ve(\'int\'  &type, \'int\'  &pid) {  &find_task_by_pid_type_all( &type,  &pid); });
	    }' unless defined(&task_struct);
	} else {
	    require 'asm/current.ph';
	    require 'linux/ve.ph';
	    eval 'sub find_task_by_pid_ve {
	        my($nr) = @_;
    		eval q( &find_task_by_pid_type_ve( &PIDTYPE_PID, $nr));
	    }' unless defined(&find_task_by_pid_ve);
	    eval 'sub VEID {
	        my($envid) = @_;
    		eval q((($envid)-> &veid));
	    }' unless defined(&VEID);
	    eval 'sub ve_is_super {
	        my($env) = @_;
    		eval q((($env) ==  &get_ve0()));
	    }' unless defined(&ve_is_super);
	    eval 'sub ve_accessible_strict {
	        my($target, $owner) = @_;
    		eval q((($target) == ($owner)));
	    }' unless defined(&ve_accessible_strict);
	    eval 'sub ve_accessible {
	        my($target,$owner) = @_;
    		eval q({  &ve_is_super($owner) ||  &ve_accessible_strict($target, $owner); });
	    }' unless defined(&ve_accessible);
	    eval 'sub ve_accessible_strict_veid {
	        my($target, $owner) = @_;
    		eval q((($target) == ($owner)));
	    }' unless defined(&ve_accessible_strict_veid);
	    eval 'sub ve_accessible_veid {
	        my($target,$owner) = @_;
    		eval q({  &get_ve0()-> &veid == $owner ||  &ve_accessible_strict_veid($target, $owner); });
	    }' unless defined(&ve_accessible_veid);
	    eval 'sub virt_pid {
	        my($tsk) = @_;
    		eval q({  ($tsk->{vpid}); });
	    }' unless defined(&virt_pid);
	    eval 'sub virt_tgid {
	        my($tsk) = @_;
    		eval q({  ($tsk->{vtgid}); });
	    }' unless defined(&virt_tgid);
	    eval 'sub virt_pgid {
	        my($tsk) = @_;
    		eval q({  ($tsk->{signal}->{vpgrp}); });
	    }' unless defined(&virt_pgid);
	    eval 'sub virt_sid {
	        my($tsk) = @_;
    		eval q({  ($tsk->{signal}->{vsession}); });
	    }' unless defined(&virt_sid);
	    eval 'sub get_task_pid_ve {
	        my($tsk,$env) = @_;
    		eval q({  &ve_is_super($env) ?  ($tsk->{pid}) :  &virt_pid($tsk); });
	    }' unless defined(&get_task_pid_ve);
	    eval 'sub get_task_pid {
	        my($tsk) = @_;
    		eval q({  &get_task_pid_ve($tsk,  &get_exec_env()); });
	    }' unless defined(&get_task_pid);
	    eval 'sub get_task_tgid {
	        my($tsk) = @_;
    		eval q({  &ve_is_super( &get_exec_env()) ?  ($tsk->{tgid}) :  &virt_tgid($tsk); });
	    }' unless defined(&get_task_tgid);
	    eval 'sub get_task_pgid {
	        my($tsk) = @_;
    		eval q({  &ve_is_super( &get_exec_env()) ?  ($tsk->{signal}->{pgrp}) :  &virt_pgid($tsk); });
	    }' unless defined(&get_task_pgid);
	    eval 'sub get_task_sid {
	        my($tsk) = @_;
    		eval q({  &ve_is_super( &get_exec_env()) ?  ($tsk->{signal}->{session}) :  &virt_sid($tsk); });
	    }' unless defined(&get_task_sid);
	    eval 'sub set_virt_pid {
	        my($tsk,$pid) = @_;
    		eval q({  ($tsk->{v$pid}) = $pid; });
	    }' unless defined(&set_virt_pid);
	    eval 'sub set_virt_tgid {
	        my($tsk,$pid) = @_;
    		eval q({  ($tsk->{vtgid}) = $pid; });
	    }' unless defined(&set_virt_tgid);
	    eval 'sub set_virt_pgid {
	        my($tsk,$pid) = @_;
    		eval q({  ($tsk->{signal}->{vpgrp}) = $pid; });
	    }' unless defined(&set_virt_pgid);
	    eval 'sub set_virt_sid {
	        my($tsk,$pid) = @_;
    		eval q({  ($tsk->{signal}->{vsession}) = $pid; });
	    }' unless defined(&set_virt_sid);
	    eval 'sub get_task_ppid {
	        my($p) = @_;
    		eval q({ \'struct task_struct\' * &parent; \'struct ve_struct\' * &env;  &if (! &pid_alive($p)) 0;  &env =  &get_exec_env();  &if ( &get_task_pid_ve($p,  &env) == 1) 0;  &parent =  ($p->{group_leader}->{parent});  &ve_accessible( &VE_TASK_INFO( &parent)-> &owner_env,  &env) ?  &get_task_tgid( &parent) : 1; });
	    }' unless defined(&get_task_ppid);
	}
	if(defined(&CONFIG_VE)) {
	} else {
	    eval 'sub ve_sched_get_idle_time {
	        my($cpu) = @_;
    		eval q(0);
	    }' unless defined(&ve_sched_get_idle_time);
	    eval 'sub ve_sched_get_idle_time_total {
	        my($ve) = @_;
    		eval q(0);
	    }' unless defined(&ve_sched_get_idle_time_total);
	    eval 'sub ve_sched_get_iowait_time {
	        my($cpu) = @_;
    		eval q(0);
	    }' unless defined(&ve_sched_get_iowait_time);
	}
	if(defined(&CONFIG_SCHED_VCPU)) {
	} else {
	    eval 'sub vsched_cpu_online_map {
	        my($vsched, $mask) = @_;
    		eval q( &do { *$mask =  &cpu_online_map; }  &while (0));
	    }' unless defined(&vsched_cpu_online_map);
	}
	eval 'sub user_struct {
	    eval q(* &get_uid(\'struct user_struct\' * &u) {  &atomic_inc( ($u->{__count}));  &u; });
	}' unless defined(&user_struct);
	require 'asm/current.ph';
	if(defined( &CONFIG_SMP) || defined ( &CONFIG_SCHED_VCPU)) {
	} else {
	}
	eval 'sub dequeue_signal_lock {
	    my($tsk,$mask,$info) = @_;
    	    eval q({ my $flags; \'int\'  &ret;  &spin_lock_irqsave( ($tsk->{sighand}->{siglock}),  $flags);  &ret =  &dequeue_signal($tsk, $mask, $info);  &spin_unlock_irqrestore( ($tsk->{sighand}->{siglock}),  $flags);  &ret; } );
	}' unless defined(&dequeue_signal_lock);
	eval 'sub SEND_SIG_NOINFO () {( 0);}' unless defined(&SEND_SIG_NOINFO);
	eval 'sub SEND_SIG_PRIV () {( 1);}' unless defined(&SEND_SIG_PRIV);
	eval 'sub SEND_SIG_FORCED () {( 2);}' unless defined(&SEND_SIG_FORCED);
	eval 'sub is_si_special {
	    my($info) = @_;
    	    eval q({ $info <=  &SEND_SIG_FORCED; });
	}' unless defined(&is_si_special);
	eval 'sub sas_ss_flags {
	    my($sp) = @_;
    	    eval q({ ( ($current->{sas_ss_size}) == 0?  &SS_DISABLE :  &on_sig_stack($sp) ?  &SS_ONSTACK : 0); });
	}' unless defined(&sas_ss_flags);
	eval 'sub mmdrop {
	    my($mm) = @_;
    	    eval q({  &if ( &atomic_dec_and_test( ($mm->{mm_count})))  &__mmdrop($mm); });
	}' unless defined(&mmdrop);
	if(defined( &CONFIG_SMP) || defined ( &CONFIG_SCHED_VCPU)) {
	} else {
	    eval 'sub wait_task_inactive {
	        my($p) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&wait_task_inactive);
	}
	eval 'sub remove_parent {
	    my($p) = @_;
    	    eval q( &list_del_init(($p)-> &sibling));
	}' unless defined(&remove_parent);
	eval 'sub add_parent {
	    my($p) = @_;
    	    eval q( &list_add_tail(($p)-> &sibling,($p)-> ($parent->{children})));
	}' unless defined(&add_parent);
	eval 'sub next_task_all {
	    my($p) = @_;
    	    eval q( &list_entry( &rcu_dereference(($p)-> ($tasks->{next})), \'struct task_struct\',  &tasks));
	}' unless defined(&next_task_all);
	eval 'sub for_each_process_all {
	    my($p) = @_;
    	    eval q( &for ($p =  &init_task ; ($p =  &next_task_all($p)) !=  &init_task ; ));
	}' unless defined(&for_each_process_all);
	eval 'sub do_each_thread_all {
	    my($g, $t) = @_;
    	    eval q( &for ($g = $t =  &init_task ; ($g = $t =  &next_task_all($g)) !=  &init_task ; )  &do);
	}' unless defined(&do_each_thread_all);
	eval 'sub while_each_thread_all {
	    my($g, $t) = @_;
    	    eval q( &while (($t =  &next_thread($t)) != $g));
	}' unless defined(&while_each_thread_all);
	unless(defined(&CONFIG_VE)) {
	    eval 'sub for_each_process_ve {
	        my($p) = @_;
    		eval q( &for_each_process_all($p));
	    }' unless defined(&for_each_process_ve);
	    eval 'sub do_each_thread_ve {
	        my($g, $t) = @_;
    		eval q( &do_each_thread_all($g, $t));
	    }' unless defined(&do_each_thread_ve);
	    eval 'sub while_each_thread_ve {
	        my($g, $t) = @_;
    		eval q( &while_each_thread_all($g, $t));
	    }' unless defined(&while_each_thread_ve);
	    eval 'sub first_task_ve () {
	        eval q( &next_task_ve( &init_task));
	    }' unless defined(&first_task_ve);
	    eval 'sub __first_task_ve {
	        my($owner) = @_;
    		eval q( &next_task_ve( &init_task));
	    }' unless defined(&__first_task_ve);
	    eval 'sub __next_task_ve {
	        my($owner, $p) = @_;
    		eval q( &next_task_ve($p));
	    }' unless defined(&__next_task_ve);
	    eval 'sub next_task_ve {
	        my($p) = @_;
    		eval q(( &next_task_all($p) !=  &init_task ?  &next_task_all($p) :  &NULL));
	    }' unless defined(&next_task_ve);
	} else {
	    eval 'sub task_struct {
	        eval q(* &ve_lh2task(\'struct ve_struct\' * &ve, \'struct list_head\' * &lh) {  &lh ==  ($ve->{vetask_lh}) ?  &NULL :  &list_entry( &lh, \'struct task_struct\',  ($ve_task_info->{vetask_list})); });
	    }' unless defined(&task_struct);
	    eval 'sub task_struct {
	        eval q(* &__first_task_ve(\'struct ve_struct\' * &ve) { \'struct task_struct\' * &tsk;  &if ( &unlikely( &ve_is_super( &ve))) {  &tsk =  &next_task_all( &init_task);  &if ( &tsk ==  &init_task)  &tsk =  &NULL; }  &else {  &tsk =  &ve_lh2task( &ve,  &rcu_dereference( ($ve->{vetask_lh}->{next}))); }  &tsk; });
	    }' unless defined(&task_struct);
	    eval 'sub task_struct {
	        eval q(* &__next_task_ve(\'struct ve_struct\' * &ve, \'struct task_struct\' * &tsk) {  &if ( &unlikely( &ve_is_super( &ve))) {  &tsk =  &next_task_all( &tsk);  &if ( &tsk ==  &init_task)  &tsk =  &NULL; }  &else {  &BUG_ON( ($tsk->{ve_task_info}->{owner_env}) !=  &ve);  &tsk =  &ve_lh2task( &ve,  &rcu_dereference( &tsk->  ($ve_task_info->{vetask_list}->{next}))); }  &tsk; });
	    }' unless defined(&task_struct);
	    eval 'sub first_task_ve () {
	        eval q( &__first_task_ve( &get_exec_env()));
	    }' unless defined(&first_task_ve);
	    eval 'sub next_task_ve {
	        my($p) = @_;
    		eval q( &__next_task_ve( &get_exec_env(), $p));
	    }' unless defined(&next_task_ve);
	    eval 'sub for_each_process_ve {
	        my($p) = @_;
    		eval q( &for ($p =  &first_task_ve(); $p !=  &NULL ; $p =  &next_task_ve($p)));
	    }' unless defined(&for_each_process_ve);
	    eval 'sub do_each_thread_ve {
	        my($g, $t) = @_;
    		eval q( &for ($g = $t =  &first_task_ve() ; $g !=  &NULL; $g = $t =  &next_task_ve($g))  &do);
	    }' unless defined(&do_each_thread_ve);
	    eval 'sub while_each_thread_ve {
	        my($g, $t) = @_;
    		eval q( &while (($t =  &next_thread($t)) != $g));
	    }' unless defined(&while_each_thread_ve);
	}
	eval 'sub thread_group_leader {
	    my($p) = @_;
    	    eval q(($p ==  ($p->{group_leader})));
	}' unless defined(&thread_group_leader);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub task_struct {
	    eval q(* &next_thread( &const \'struct task_struct\' * &p) { \'struct task_struct\' * &tsk;  &tsk =  &list_entry( &rcu_dereference( ($p->{thread_group}->{next})), \'struct task_struct\',  &thread_group);  &tsk; });
	}' unless defined(&task_struct);
	eval 'sub thread_group_empty {
	    my($p) = @_;
    	    eval q({  &list_empty( ($p->{thread_group})); });
	}' unless defined(&thread_group_empty);
	eval 'sub delay_group_leader {
	    my($p) = @_;
    	    eval q(( &thread_group_leader($p)  && ! &thread_group_empty($p)));
	}' unless defined(&delay_group_leader);
	eval 'sub task_unlock {
	    my($p) = @_;
    	    eval q({  &spin_unlock( ($p->{alloc_lock})); });
	}' unless defined(&task_unlock);
	eval 'sub unlock_task_sighand {
	    my($tsk,$flags) = @_;
    	    eval q({  &spin_unlock_irqrestore( ($tsk->{sighand}->{siglock}), *$flags); });
	}' unless defined(&unlock_task_sighand);
	unless(defined(&__HAVE_THREAD_FUNCTIONS)) {
	    eval 'sub task_thread_info {
	        my($task) = @_;
    		eval q(($task)-> &thread_info);
	    }' unless defined(&task_thread_info);
	    eval 'sub task_stack_page {
	        my($task) = @_;
    		eval q((( &void*)(($task)-> &thread_info)));
	    }' unless defined(&task_stack_page);
	    eval 'sub setup_thread_stack {
	        my($p,$org) = @_;
    		eval q({ * &task_thread_info($p) = * &task_thread_info($org);  &task_thread_info($p)-> &task = $p; });
	    }' unless defined(&setup_thread_stack);
	    eval 'sub long {
	        eval q(* &end_of_stack(\'struct task_struct\' * &p) { ( ($p->{thread_info}) + 1); });
	    }' unless defined(&long);
	}
	eval 'sub clear_tsk_thread_flag {
	    my($tsk,$flag) = @_;
    	    eval q({  &clear_ti_thread_flag( &task_thread_info($tsk), $flag); });
	}' unless defined(&clear_tsk_thread_flag);
	eval 'sub test_and_set_tsk_thread_flag {
	    my($tsk,$flag) = @_;
    	    eval q({  &test_and_set_ti_thread_flag( &task_thread_info($tsk), $flag); });
	}' unless defined(&test_and_set_tsk_thread_flag);
	eval 'sub test_and_clear_tsk_thread_flag {
	    my($tsk,$flag) = @_;
    	    eval q({  &test_and_clear_ti_thread_flag( &task_thread_info($tsk), $flag); });
	}' unless defined(&test_and_clear_tsk_thread_flag);
	eval 'sub test_tsk_thread_flag {
	    my($tsk,$flag) = @_;
    	    eval q({  &test_ti_thread_flag( &task_thread_info($tsk), $flag); });
	}' unless defined(&test_tsk_thread_flag);
	eval 'sub set_tsk_need_resched {
	    my($tsk) = @_;
    	    eval q({  &set_tsk_thread_flag($tsk, &TIF_NEED_RESCHED); });
	}' unless defined(&set_tsk_need_resched);
	eval 'sub clear_tsk_need_resched {
	    my($tsk) = @_;
    	    eval q({  &clear_tsk_thread_flag($tsk, &TIF_NEED_RESCHED); });
	}' unless defined(&clear_tsk_need_resched);
	eval 'sub signal_pending {
	    my($p) = @_;
    	    eval q({  &unlikely( &test_tsk_thread_flag($p, &TIF_SIGPENDING)); });
	}' unless defined(&signal_pending);
	eval 'sub fatal_signal_pending {
	    my($p) = @_;
    	    eval q({  &signal_pending($p)  &&  &__fatal_signal_pending($p); });
	}' unless defined(&fatal_signal_pending);
	eval 'sub need_resched {
	    my($void) = @_;
    	    eval q({  &unlikely( &test_thread_flag( &TIF_NEED_RESCHED)); });
	}' unless defined(&need_resched);
	if(defined( &CONFIG_PREEMPT)  && defined( &CONFIG_SMP)) {
	    eval 'sub need_lockbreak {
	        my($lock) = @_;
    		eval q((($lock)-> &break_lock));
	    }' unless defined(&need_lockbreak);
	} else {
	    eval 'sub need_lockbreak {
	        my($lock) = @_;
    		eval q(0);
	    }' unless defined(&need_lockbreak);
	}
	if(defined(&CONFIG_SMP)) {
	    eval 'sub task_pcpu {
	        my($p) = @_;
    		eval q({  &task_thread_info($p)-> &cpu; });
	    }' unless defined(&task_pcpu);
	    eval 'sub set_task_pcpu {
	        my($p,$cpu) = @_;
    		eval q({  &task_thread_info($p)->$cpu = $cpu; });
	    }' unless defined(&set_task_pcpu);
	} else {
	    eval 'sub task_pcpu {
	        my($p) = @_;
    		eval q({ 0; });
	    }' unless defined(&task_pcpu);
	    eval 'sub set_task_pcpu {
	        my($p,$cpu) = @_;
    		eval q({ });
	    }' unless defined(&set_task_pcpu);
	}
	if(defined(&CONFIG_SCHED_VCPU)) {
	    eval 'sub task_vsched_id {
	        my($p) = @_;
    		eval q({  ($p->{vsched_id}); });
	    }' unless defined(&task_vsched_id);
	    eval 'sub task_cpu {
	        my($p) = @_;
    		eval q({  ($p->{vcpu_id}); });
	    }' unless defined(&task_cpu);
	} else {
	    eval 'sub task_vsched_id {
	        my($p) = @_;
    		eval q({ 0; });
	    }' unless defined(&task_vsched_id);
	    eval 'sub task_cpu {
	        my($p) = @_;
    		eval q({  &task_pcpu($p); });
	    }' unless defined(&task_cpu);
	    eval 'sub set_task_cpu {
	        my($p,$cpu) = @_;
    		eval q({  &set_task_pcpu($p, $cpu); });
	    }' unless defined(&set_task_cpu);
	    eval 'sub vcpu_online {
	        my($cpu) = @_;
    		eval q( &cpu_online($cpu));
	    }' unless defined(&vcpu_online);
	}
	if(defined(&HAVE_ARCH_PICK_MMAP_LAYOUT)) {
	} else {
	    eval 'sub arch_pick_mmap_layout {
	        my($mm) = @_;
    		eval q({  ($mm->{mmap_base}) =  &TASK_UNMAPPED_BASE;  ($mm->{get_unmapped_area}) =  &arch_get_unmapped_area;  ($mm->{unmap_area}) =  &arch_unmap_area; });
	    }' unless defined(&arch_pick_mmap_layout);
	}
	require 'linux/sysdev.ph';
	if(defined(&CONFIG_PM)) {
	} else {
	}
	eval 'sub try_to_freeze {
	    my($void) = @_;
    	    eval q({  &if ( &freezing( &current)) {  &refrigerator(); 1; }  &else 0; });
	}' unless defined(&try_to_freeze);
    }
}
1;
