require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_VE_H)) {
    eval 'sub _LINUX_VE_H () {1;}' unless defined(&_LINUX_VE_H);
    require 'linux/config.ph';
    unless(defined(&__ENVID_T_DEFINED__)) {
	eval 'sub __ENVID_T_DEFINED__ () {1;}' unless defined(&__ENVID_T_DEFINED__);
    }
    require 'linux/types.ph';
    require 'linux/capability.ph';
    require 'linux/utsname.ph';
    require 'linux/sysctl.ph';
    require 'linux/net.ph';
    require 'linux/vzstat.ph';
    require 'linux/kobject.ph';
    require 'linux/pid.ph';
    if(defined(&VZMON_DEBUG)) {
	eval 'sub VZTRACE () {( &fmt, &args...)  &printk( &KERN_DEBUG  &fmt,  &args);}' unless defined(&VZTRACE);
    } else {
	eval 'sub VZTRACE () {( &fmt, &args...);}' unless defined(&VZTRACE);
    }
    if(defined( &CONFIG_VE)  && defined( &CONFIG_INET)) {
	if(defined(&CONFIG_VE_IPTABLES)) {
	    if(defined(&CONFIG_SYSCTL)) {
	    }
	}
    }
    eval 'sub UIDHASH_BITS_VE () {6;}' unless defined(&UIDHASH_BITS_VE);
    eval 'sub UIDHASH_SZ_VE () {(1<<  &UIDHASH_BITS_VE);}' unless defined(&UIDHASH_SZ_VE);
    if(defined( &CONFIG_IPV6) || defined( &CONFIG_IPV6_MODULE)) {
    }
    if(defined(&CONFIG_LEGACY_PTYS)) {
    }
    if(defined(&CONFIG_UNIX98_PTYS)) {
    }
    if(defined(&CONFIG_SYSFS)) {
    }
    if(defined(&CONFIG_NET)) {
	if(defined(&CONFIG_INET)) {
	    if(defined( &CONFIG_IPV6) || defined( &CONFIG_IPV6_MODULE)) {
	    }
	}
    }
    if(defined( &CONFIG_VE_NETDEV) || defined ( &CONFIG_VE_NETDEV_MODULE)) {
    }
    if(defined( &CONFIG_PPP) || defined( &CONFIG_PPP_MODULE)) {
	if(defined( &CONFIG_PPPOE) || defined( &CONFIG_PPPOE_MODULE)) {
	}
    }
    if(defined( &CONFIG_BRIDGE) || defined( &CONFIG_BRIDGE_MODULE)) {
    }
    if(defined(&CONFIG_INET)) {
	if(defined(&CONFIG_FIB_RULES)) {
	}
	if(defined(&CONFIG_IP_MULTIPLE_TABLES)) {
	} else {
	}
	if(defined(&CONFIG_VE_IPTABLES)) {
	}
	if(defined( &CONFIG_IPV6) || defined( &CONFIG_IPV6_MODULE)) {
	    if(defined(&CONFIG_IPV6_MULTIPLE_TABLES)) {
	    } else {
	    }
	}
    }
    eval 'sub VE_DEFAULT_LOG_BUF_LEN () {4096;}' unless defined(&VE_DEFAULT_LOG_BUF_LEN);
    if(defined( &CONFIG_FUSE_FS) || defined( &CONFIG_FUSE_FS_MODULE)) {
    }
    if(defined( &CONFIG_VLAN_8021Q) || defined( &CONFIG_VLAN_8021Q_MODULE)) {
    }
    if(defined( &CONFIG_BINFMT_MISC) || defined( &CONFIG_BINFMT_MISC_MODULE)) {
    }
    if(defined( &CONFIG_NFS_FS) || defined( &CONFIG_NFS_FS_MODULE) || defined( &CONFIG_NFSD) || defined( &CONFIG_NFSD_MODULE)) {
    }
    if(defined(&CONFIG_GRKERNSEC)) {
	if(defined(&CONFIG_GRKERNSEC_TPE)) {
	    if(defined(&CONFIG_GRKERNSEC_TPE_ALL)) {
	    }
	}
    }
    if(defined(&CONFIG_BSD_PROCESS_ACCT)) {
    }
    if(defined( &CONFIG_HOTPLUG)) {
    }
    eval 'sub VE_MEMINFO_DEFAULT () {1;}' unless defined(&VE_MEMINFO_DEFAULT);
    eval 'sub VE_MEMINFO_SYSTEM () {0;}' unless defined(&VE_MEMINFO_SYSTEM);
    eval("sub VE_REBOOT () { 0; }") unless defined(&VE_REBOOT);
    eval 'sub VE_CPU_STATS {
        my($ve, $cpu) = @_;
	    eval q(( &per_cpu_ptr(($ve)-> &cpu_stats, $cpu)));
    }' unless defined(&VE_CPU_STATS);
    if(defined(&CONFIG_VE)) {
	eval 'sub ve_struct {
	    eval q(* &get_ve(\'struct ve_struct\' * &ptr) {  &if ( &ptr !=  &NULL)  &atomic_inc( ($ptr->{counter}));  &ptr; });
	}' unless defined(&ve_struct);
	eval 'sub put_ve {
	    my($ptr) = @_;
    	    eval q({  &if ($ptr  &&  &atomic_dec_and_test( ($ptr->{counter}))) {  &if ( &atomic_read( ($ptr->{pcounter})) > 0)  &BUG();  &if ( ($ptr->{is_running}))  &BUG();  &do_env_free($ptr); } });
	}' unless defined(&put_ve);
	eval 'sub pget_ve {
	    my($ptr) = @_;
    	    eval q({  &atomic_inc( ($ptr->{pcounter})); });
	}' unless defined(&pget_ve);
	eval 'sub pput_ve {
	    my($ptr) = @_;
    	    eval q({  &if ( &unlikely( &atomic_dec_and_test( ($ptr->{pcounter}))))  &ve_cleanup_schedule($ptr); });
	}' unless defined(&pput_ve);
	if(defined(&CONFIG_FAIRSCHED)) {
	    eval 'sub ve_cpu_online_map {
	        my($ve, $mask) = @_;
    		eval q( &fairsched_cpu_online_map( ($ve->{veid}), $mask));
	    }' unless defined(&ve_cpu_online_map);
	} else {
	    eval 'sub ve_cpu_online_map {
	        my($ve, $mask) = @_;
    		eval q( &do { *($mask) =  &cpu_online_map; }  &while (0));
	    }' unless defined(&ve_cpu_online_map);
	}
    } else {
	eval 'sub ve_utsname () { &system_utsname;}' unless defined(&ve_utsname);
	eval 'sub get_ve {
	    my($ve) = @_;
    	    eval q(( &NULL));
	}' unless defined(&get_ve);
	eval 'sub put_ve {
	    my($ve) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&put_ve);
	eval 'sub pget_ve {
	    my($ve) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&pget_ve);
	eval 'sub pput_ve {
	    my($ve) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&pput_ve);
    }
}
1;
