require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_VZCALLUSER_H)) {
    eval 'sub _LINUX_VZCALLUSER_H () {1;}' unless defined(&_LINUX_VZCALLUSER_H);
    require 'linux/types.ph';
    require 'linux/ioctl.ph';
    eval 'sub KERN_VZ_PRIV_RANGE () {51;}' unless defined(&KERN_VZ_PRIV_RANGE);
    unless(defined(&__ENVID_T_DEFINED__)) {
	eval 'sub __ENVID_T_DEFINED__ () {1;}' unless defined(&__ENVID_T_DEFINED__);
    }
    unless(defined(&__KERNEL__)) {
	eval 'sub __user () {1;}' unless defined(&__user);
    }
    eval 'sub VE_CREATE () {1;}' unless defined(&VE_CREATE);
    eval 'sub VE_EXCLUSIVE () {2;}' unless defined(&VE_EXCLUSIVE);
    eval 'sub VE_ENTER () {4;}' unless defined(&VE_ENTER);
    eval 'sub VE_TEST () {8;}' unless defined(&VE_TEST);
    eval 'sub VE_LOCK () {16;}' unless defined(&VE_LOCK);
    eval 'sub VE_SKIPLOCK () {32;}' unless defined(&VE_SKIPLOCK);
    eval 'sub VE_USE_MAJOR () {010;}' unless defined(&VE_USE_MAJOR);
    eval 'sub VE_USE_MINOR () {030;}' unless defined(&VE_USE_MINOR);
    eval 'sub VE_USE_MASK () {030;}' unless defined(&VE_USE_MASK);
    eval 'sub VE_NETDEV_ADD () {1;}' unless defined(&VE_NETDEV_ADD);
    eval 'sub VE_NETDEV_DEL () {2;}' unless defined(&VE_NETDEV_DEL);
    eval 'sub VE_CONFIGURE_OS_RELEASE () {2;}' unless defined(&VE_CONFIGURE_OS_RELEASE);
    eval 'sub VE_IP_IPTABLES_MOD () {(1<<0);}' unless defined(&VE_IP_IPTABLES_MOD);
    eval 'sub VE_IP_FILTER_MOD () {(1<<1);}' unless defined(&VE_IP_FILTER_MOD);
    eval 'sub VE_IP_MANGLE_MOD () {(1<<2);}' unless defined(&VE_IP_MANGLE_MOD);
    eval 'sub VE_IP_CONNTRACK_MOD () {(1<<14);}' unless defined(&VE_IP_CONNTRACK_MOD);
    eval 'sub VE_IP_CONNTRACK_FTP_MOD () {(1<<15);}' unless defined(&VE_IP_CONNTRACK_FTP_MOD);
    eval 'sub VE_IP_CONNTRACK_IRC_MOD () {(1<<16);}' unless defined(&VE_IP_CONNTRACK_IRC_MOD);
    eval 'sub VE_IP_NAT_MOD () {(1<<20);}' unless defined(&VE_IP_NAT_MOD);
    eval 'sub VE_IP_NAT_FTP_MOD () {(1<<21);}' unless defined(&VE_IP_NAT_FTP_MOD);
    eval 'sub VE_IP_NAT_IRC_MOD () {(1<<22);}' unless defined(&VE_IP_NAT_IRC_MOD);
    eval 'sub VE_IP_IPTABLES6_MOD () {(1<<26);}' unless defined(&VE_IP_IPTABLES6_MOD);
    eval 'sub VE_IP_FILTER6_MOD () {(1<<27);}' unless defined(&VE_IP_FILTER6_MOD);
    eval 'sub VE_IP_MANGLE6_MOD () {(1<<28);}' unless defined(&VE_IP_MANGLE6_MOD);
    eval 'sub VE_IP_IPTABLE_NAT_MOD () {(1<<29);}' unless defined(&VE_IP_IPTABLE_NAT_MOD);
    eval 'sub VE_IP_IPTABLES () {( &VE_IP_IPTABLES_MOD);}' unless defined(&VE_IP_IPTABLES);
    eval 'sub VE_IP_FILTER () {( &VE_IP_FILTER_MOD |  &VE_IP_IPTABLES);}' unless defined(&VE_IP_FILTER);
    eval 'sub VE_IP_MANGLE () {( &VE_IP_MANGLE_MOD |  &VE_IP_IPTABLES);}' unless defined(&VE_IP_MANGLE);
    eval 'sub VE_IP_IPTABLES6 () {( &VE_IP_IPTABLES6_MOD);}' unless defined(&VE_IP_IPTABLES6);
    eval 'sub VE_IP_FILTER6 () {( &VE_IP_FILTER6_MOD |  &VE_IP_IPTABLES6);}' unless defined(&VE_IP_FILTER6);
    eval 'sub VE_IP_MANGLE6 () {( &VE_IP_MANGLE6_MOD |  &VE_IP_IPTABLES6);}' unless defined(&VE_IP_MANGLE6);
    eval 'sub VE_IP_CONNTRACK () {( &VE_IP_CONNTRACK_MOD |  &VE_IP_IPTABLES);}' unless defined(&VE_IP_CONNTRACK);
    eval 'sub VE_IP_CONNTRACK_FTP () {( &VE_IP_CONNTRACK_FTP_MOD |  &VE_IP_CONNTRACK);}' unless defined(&VE_IP_CONNTRACK_FTP);
    eval 'sub VE_IP_CONNTRACK_IRC () {( &VE_IP_CONNTRACK_IRC_MOD |  &VE_IP_CONNTRACK);}' unless defined(&VE_IP_CONNTRACK_IRC);
    eval 'sub VE_IP_NAT () {( &VE_IP_NAT_MOD |  &VE_IP_CONNTRACK);}' unless defined(&VE_IP_NAT);
    eval 'sub VE_IP_NAT_FTP () {( &VE_IP_NAT_FTP_MOD |  &VE_IP_NAT |  &VE_IP_CONNTRACK_FTP);}' unless defined(&VE_IP_NAT_FTP);
    eval 'sub VE_IP_NAT_IRC () {( &VE_IP_NAT_IRC_MOD |  &VE_IP_NAT |  &VE_IP_CONNTRACK_IRC);}' unless defined(&VE_IP_NAT_IRC);
    eval 'sub VE_IP_IPTABLE_NAT () {( &VE_IP_IPTABLE_NAT_MOD |  &VE_IP_CONNTRACK);}' unless defined(&VE_IP_IPTABLE_NAT);
    eval 'sub VE_IP_DEFAULT () {( &VE_IP_IPTABLES |  &VE_IP_FILTER |  &VE_IP_MANGLE);}' unless defined(&VE_IP_DEFAULT);
    eval 'sub VE_IPT_CMP {
        my($x,$y) = @_;
	    eval q(((($x) & ($y)) == ($y)));
    }' unless defined(&VE_IPT_CMP);
    eval 'sub VZCTL_ENV_CREATE_DATA_MINLEN () {$sizeof{\'struct env_create_param\'};}' unless defined(&VZCTL_ENV_CREATE_DATA_MINLEN);
    eval 'sub VE_FEATURE_SYSFS () {(1 << 0);}' unless defined(&VE_FEATURE_SYSFS);
    eval 'sub VE_FEATURE_NFS () {(1 << 1);}' unless defined(&VE_FEATURE_NFS);
    eval 'sub VE_FEATURE_DEF_PERMS () {(1 << 2);}' unless defined(&VE_FEATURE_DEF_PERMS);
    eval 'sub VE_FEATURE_SIT () {(1 << 3);}' unless defined(&VE_FEATURE_SIT);
    eval 'sub VE_FEATURE_IPIP () {(1 << 4);}' unless defined(&VE_FEATURE_IPIP);
    eval 'sub VE_FEATURE_PPP () {(1 << 5);}' unless defined(&VE_FEATURE_PPP);
    eval 'sub VE_FEATURE_IPGRE () {(1 << 6);}' unless defined(&VE_FEATURE_IPGRE);
    eval 'sub VE_FEATURE_BRIDGE () {(1 << 7);}' unless defined(&VE_FEATURE_BRIDGE);
    eval 'sub VE_FEATURE_NFSD () {(1 << 8);}' unless defined(&VE_FEATURE_NFSD);
    eval 'sub VE_FEATURES_OLD () {( &VE_FEATURE_SYSFS);}' unless defined(&VE_FEATURES_OLD);
    eval 'sub VE_FEATURES_DEF () {( &VE_FEATURE_SYSFS |  &VE_FEATURE_DEF_PERMS);}' unless defined(&VE_FEATURES_DEF);
    eval 'sub VZCTL_ENV_CREATE_DATA_MAXLEN () {$sizeof{ &env_create_param_t};}' unless defined(&VZCTL_ENV_CREATE_DATA_MAXLEN);
    eval 'sub VZCTLTYPE () {ord(\'.\');}' unless defined(&VZCTLTYPE);
    eval 'sub VZCTL_OLD_ENV_CREATE () { &_IOW( &VZCTLTYPE, 0, \'struct vzctl_old_env_create\');}' unless defined(&VZCTL_OLD_ENV_CREATE);
    eval 'sub VZCTL_MARK_ENV_TO_DOWN () { &_IOW( &VZCTLTYPE, 1, \'struct vzctl_mark_env_to_down\');}' unless defined(&VZCTL_MARK_ENV_TO_DOWN);
    eval 'sub VZCTL_SETDEVPERMS () { &_IOW( &VZCTLTYPE, 2, \'struct vzctl_setdevperms\');}' unless defined(&VZCTL_SETDEVPERMS);
    eval 'sub VZCTL_ENV_CREATE_CID () { &_IOW( &VZCTLTYPE, 4, \'struct vzctl_env_create_cid\');}' unless defined(&VZCTL_ENV_CREATE_CID);
    eval 'sub VZCTL_ENV_CREATE () { &_IOW( &VZCTLTYPE, 5, \'struct vzctl_env_create\');}' unless defined(&VZCTL_ENV_CREATE);
    eval 'sub VZCTL_GET_CPU_STAT () { &_IOW( &VZCTLTYPE, 6, \'struct vzctl_cpustatctl\');}' unless defined(&VZCTL_GET_CPU_STAT);
    eval 'sub VZCTL_ENV_CREATE_DATA () { &_IOW( &VZCTLTYPE, 10, \'struct vzctl_env_create_data\');}' unless defined(&VZCTL_ENV_CREATE_DATA);
    eval 'sub VZCTL_VE_NETDEV () { &_IOW( &VZCTLTYPE, 11, \'struct vzctl_ve_netdev\');}' unless defined(&VZCTL_VE_NETDEV);
    eval 'sub VZCTL_VE_MEMINFO () { &_IOW( &VZCTLTYPE, 13, \'struct vzctl_ve_meminfo\');}' unless defined(&VZCTL_VE_MEMINFO);
    eval 'sub VZCTL_VE_CONFIGURE () { &_IOW( &VZCTLTYPE, 15, \'struct vzctl_ve_configure\');}' unless defined(&VZCTL_VE_CONFIGURE);
    if(defined(&__KERNEL__)) {
	if(defined(&CONFIG_COMPAT)) {
	    require 'linux/compat.ph';
	    eval 'sub VZCTL_COMPAT_ENV_CREATE_DATA () { &_IOW( &VZCTLTYPE, 10, \'struct compat_vzctl_env_create_data\');}' unless defined(&VZCTL_COMPAT_ENV_CREATE_DATA);
	    eval 'sub VZCTL_COMPAT_VE_NETDEV () { &_IOW( &VZCTLTYPE, 11, \'struct compat_vzctl_ve_netdev\');}' unless defined(&VZCTL_COMPAT_VE_NETDEV);
	    eval 'sub VZCTL_COMPAT_VE_MEMINFO () { &_IOW( &VZCTLTYPE, 13, \'struct compat_vzctl_ve_meminfo\');}' unless defined(&VZCTL_COMPAT_VE_MEMINFO);
	}
    }
}
1;
