require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_VZDQUOTA_H)) {
    eval 'sub _VZDQUOTA_H () {1;}' unless defined(&_VZDQUOTA_H);
    require 'linux/types.ph';
    require 'linux/quota.ph';
    eval 'sub VZ_DQ_CREATE () {5;}' unless defined(&VZ_DQ_CREATE);
    eval 'sub VZ_DQ_DESTROY () {6;}' unless defined(&VZ_DQ_DESTROY);
    eval 'sub VZ_DQ_ON () {7;}' unless defined(&VZ_DQ_ON);
    eval 'sub VZ_DQ_OFF () {8;}' unless defined(&VZ_DQ_OFF);
    eval 'sub VZ_DQ_SETLIMIT () {9;}' unless defined(&VZ_DQ_SETLIMIT);
    eval 'sub VZ_DQ_GETSTAT () {10;}' unless defined(&VZ_DQ_GETSTAT);
    eval 'sub VZ_DQ_OFF_FORCED () {11;}' unless defined(&VZ_DQ_OFF_FORCED);
    eval 'sub VZ_DQ_UGID_GETSTAT () {1;}' unless defined(&VZ_DQ_UGID_GETSTAT);
    eval 'sub VZ_DQ_UGID_ADDSTAT () {2;}' unless defined(&VZ_DQ_UGID_ADDSTAT);
    eval 'sub VZ_DQ_UGID_GETGRACE () {3;}' unless defined(&VZ_DQ_UGID_GETGRACE);
    eval 'sub VZ_DQ_UGID_SETGRACE () {4;}' unless defined(&VZ_DQ_UGID_SETGRACE);
    eval 'sub VZ_DQ_UGID_GETCONFIG () {5;}' unless defined(&VZ_DQ_UGID_GETCONFIG);
    eval 'sub VZ_DQ_UGID_SETCONFIG () {6;}' unless defined(&VZ_DQ_UGID_SETCONFIG);
    eval 'sub VZ_DQ_UGID_SETLIMIT () {7;}' unless defined(&VZ_DQ_UGID_SETLIMIT);
    eval 'sub VZ_DQ_UGID_SETINFO () {8;}' unless defined(&VZ_DQ_UGID_SETINFO);
    eval 'sub CURRENT_TIME_SECONDS () {( &get_seconds());}' unless defined(&CURRENT_TIME_SECONDS);
    eval 'sub VZ_QUOTA_INODES () {0x1;}' unless defined(&VZ_QUOTA_INODES);
    eval 'sub VZ_QUOTA_SPACE () {0x2;}' unless defined(&VZ_QUOTA_SPACE);
    if(defined(&CONFIG_COMPAT)) {
	require 'linux/compat.ph';
	eval 'sub compat_dqstat2dqstat {
	    my($odqs,$dqs) = @_;
    	    eval q({  ($dqs->{bhardlimit}) =  ($o$dqs->{bhardlimit});  ($dqs->{bsoftlimit}) =  ($o$dqs->{bsoftlimit});  ($dqs->{bcurrent}) =  ($o$dqs->{bcurrent});  ($dqs->{btime}) =  ($o$dqs->{btime});  ($dqs->{ihardlimit}) =  ($o$dqs->{ihardlimit});  ($dqs->{isoftlimit}) =  ($o$dqs->{isoftlimit});  ($dqs->{icurrent}) =  ($o$dqs->{icurrent});  ($dqs->{itime}) =  ($o$dqs->{itime}); });
	}' unless defined(&compat_dqstat2dqstat);
	eval 'sub compat_dqinfo2dqinfo {
	    my($odqi,$dqi) = @_;
    	    eval q({  ($dqi->{bexpire}) =  ($o$dqi->{bexpire});  ($dqi->{iexpire}) =  ($o$dqi->{iexpire});  ($dqi->{flags}) =  ($o$dqi->{flags}); });
	}' unless defined(&compat_dqinfo2dqinfo);
	eval 'sub dqstat2compat_dqstat {
	    my($dqs,$odqs) = @_;
    	    eval q({  ($o$dqs->{bhardlimit}) =  ($dqs->{bhardlimit});  ($o$dqs->{bsoftlimit}) =  ($dqs->{bsoftlimit});  ($o$dqs->{bcurrent}) =  ($dqs->{bcurrent});  ($o$dqs->{btime}) = ( &compat_time_t) ($dqs->{btime});  ($o$dqs->{ihardlimit}) =  ($dqs->{ihardlimit});  ($o$dqs->{isoftlimit}) =  ($dqs->{isoftlimit});  ($o$dqs->{icurrent}) =  ($dqs->{icurrent});  ($o$dqs->{itime}) = ( &compat_time_t) ($dqs->{itime}); });
	}' unless defined(&dqstat2compat_dqstat);
	eval 'sub dqinfo2compat_dqinfo {
	    my($dqi,$odqi) = @_;
    	    eval q({  ($o$dqi->{bexpire}) = ( &compat_time_t) ($dqi->{bexpire});  ($o$dqi->{iexpire}) = ( &compat_time_t) ($dqi->{iexpire});  ($o$dqi->{flags}) =  ($dqi->{flags}); });
	}' unless defined(&dqinfo2compat_dqinfo);
    }
    eval 'sub VZDQUG_FIXED_SET () {0x1;}' unless defined(&VZDQUG_FIXED_SET);
    eval 'sub VZDQUG_ON () {0x2;}' unless defined(&VZDQUG_ON);
    eval 'sub VZDQ_USRQUOTA () {0x10;}' unless defined(&VZDQ_USRQUOTA);
    eval 'sub VZDQ_GRPQUOTA () {0x20;}' unless defined(&VZDQ_GRPQUOTA);
    eval 'sub VZDQ_NOACT () {0x1000;}' unless defined(&VZDQ_NOACT);
    eval 'sub VZDQ_NOQUOT () {0x2000;}' unless defined(&VZDQ_NOQUOT);
    if(defined(&__KERNEL__)) {
	require 'linux/list.ph';
	require 'asm/atomic.ph';
	require 'asm/semaphore.ph';
	require 'linux/time.ph';
	require 'linux/vzquota_qlnk.ph';
	require 'linux/vzdq_tree.ph';
	eval 'sub VZ_QUOTA_INODES () {0x1;}' unless defined(&VZ_QUOTA_INODES);
	eval 'sub VZ_QUOTA_SPACE () {0x2;}' unless defined(&VZ_QUOTA_SPACE);
	eval 'sub VZDQ_STARTING () {0;}' unless defined(&VZDQ_STARTING);
	eval 'sub VZDQ_WORKING () {1;}' unless defined(&VZDQ_WORKING);
	eval 'sub VZDQ_STOPING () {2;}' unless defined(&VZDQ_STOPING);
	eval 'sub VZ_QUOTA_UGBAD () {(0xfeafea11);}' unless defined(&VZ_QUOTA_UGBAD);
	eval 'sub VIRTINFO_QUOTA_GETSTAT () {0;}' unless defined(&VIRTINFO_QUOTA_GETSTAT);
	eval 'sub VIRTINFO_QUOTA_ON () {1;}' unless defined(&VIRTINFO_QUOTA_ON);
	eval 'sub VIRTINFO_QUOTA_OFF () {2;}' unless defined(&VIRTINFO_QUOTA_OFF);
	eval 'sub VIRTINFO_QUOTA_DISABLE () {3;}' unless defined(&VIRTINFO_QUOTA_DISABLE);
	eval 'sub INODE_QLNK {
	    my($inode) = @_;
    	    eval q((($inode)-> &i_qlnk));
	}' unless defined(&INODE_QLNK);
	eval 'sub QLNK_INODE {
	    my($qlnk) = @_;
    	    eval q( &container_of(($qlnk), \'struct inode\',  &i_qlnk));
	}' unless defined(&QLNK_INODE);
	eval 'sub VZ_QUOTA_BAD () {(0xefefefef);}' unless defined(&VZ_QUOTA_BAD);
	eval 'sub VZ_QUOTAO_SETE () {1;}' unless defined(&VZ_QUOTAO_SETE);
	eval 'sub VZ_QUOTAO_INIT () {2;}' unless defined(&VZ_QUOTAO_INIT);
	eval 'sub VZ_QUOTAO_DESTR () {3;}' unless defined(&VZ_QUOTAO_DESTR);
	eval 'sub VZ_QUOTAO_SWAP () {4;}' unless defined(&VZ_QUOTAO_SWAP);
	eval 'sub VZ_QUOTAO_INICAL () {5;}' unless defined(&VZ_QUOTAO_INICAL);
	eval 'sub VZ_QUOTAO_DRCAL () {6;}' unless defined(&VZ_QUOTAO_DRCAL);
	eval 'sub VZ_QUOTAO_QSET () {7;}' unless defined(&VZ_QUOTAO_QSET);
	eval 'sub VZ_QUOTAO_TRANS () {8;}' unless defined(&VZ_QUOTAO_TRANS);
	eval 'sub VZ_QUOTAO_ACT () {9;}' unless defined(&VZ_QUOTAO_ACT);
	eval 'sub VZ_QUOTAO_DTREE () {10;}' unless defined(&VZ_QUOTAO_DTREE);
	eval 'sub VZ_QUOTAO_DET () {11;}' unless defined(&VZ_QUOTAO_DET);
	eval 'sub VZ_QUOTAO_ON () {12;}' unless defined(&VZ_QUOTAO_ON);
	eval 'sub VZ_QUOTAO_RE_LOCK () {13;}' unless defined(&VZ_QUOTAO_RE_LOCK);
	eval 'sub DQUOT_CMD_ALLOC () {0;}' unless defined(&DQUOT_CMD_ALLOC);
	eval 'sub DQUOT_CMD_PREALLOC () {1;}' unless defined(&DQUOT_CMD_PREALLOC);
	eval 'sub DQUOT_CMD_CHECK () {12;}' unless defined(&DQUOT_CMD_CHECK);
	eval 'sub DQUOT_CMD_FORCE () {13;}' unless defined(&DQUOT_CMD_FORCE);
	eval 'sub VZDQ_CUR_MAGIC () {0x57d0fee2;}' unless defined(&VZDQ_CUR_MAGIC);
	eval 'sub vzquota_cur_qmblk_set {
	    my($data) = @_;
    	    eval q({ \'struct task_struct\' * &tsk;  &tsk =  &current;  ($tsk->{magic}) =  &VZDQ_CUR_MAGIC;  ($tsk->{ino}) = $data; });
	}' unless defined(&vzquota_cur_qmblk_set);
	eval 'sub vz_quota_master {
	    eval q(* &qmblk_get(\'struct vz_quota_master\' * &qmblk) {  &if (! &atomic_read( ($qmblk->{dq_count})))  &BUG();  &atomic_inc( ($qmblk->{dq_count}));  &qmblk; });
	}' unless defined(&vz_quota_master);
	eval 'sub __qmblk_put {
	    my($qmblk) = @_;
    	    eval q({  &atomic_dec( ($qmblk->{dq_count})); });
	}' unless defined(&__qmblk_put);
	eval 'sub qmblk_put {
	    my($qmblk) = @_;
    	    eval q({  &if (! &atomic_dec_and_test( ($qmblk->{dq_count}))) ;  &vzquota_free_master($qmblk); });
	}' unless defined(&qmblk_put);
	eval 'sub QUGID_TREE {
	    my($qmblk, $type) = @_;
    	    eval q(((($type) ==  &USRQUOTA) ?  ($qmblk->{dq_uid_tree}) :  ($qmblk->{dq_gid_tree})));
	}' unless defined(&QUGID_TREE);
	eval 'sub VZDQUG_FIND_DONT_ALLOC () {1;}' unless defined(&VZDQUG_FIND_DONT_ALLOC);
	eval 'sub VZDQUG_FIND_FAKE () {2;}' unless defined(&VZDQUG_FIND_FAKE);
    }
}
1;
